Package: mipfp
Type: Package
Title: Multidimensional Iterative Proportional Fitting and Alternative
        Models
Version: 3.2.3
Date: 2026-08-22
Authors@R: c(
    person("Johan", "Barthelemy", role = c("aut", "cre"), email = "johan@uow.edu.au"), 
    person("Thomas", "Suesse", role = "aut"), 
    person("Mohammad", "Namazi-Rad", role = "ctb"))
Author: Johan Barthelemy [aut, cre],
  Thomas Suesse [aut],
  Mohammad Namazi-Rad [ctb]
Maintainer: Johan Barthelemy <johan@uow.edu.au>
Description: An implementation of the iterative proportional fitting (IPFP), 
    maximum likelihood, minimum chi-square and weighted least squares procedures
    for updating a N-dimensional array with respect to given target marginal 
    distributions (which, in turn can be multidimensional). The package also
    provides an application of the IPFP to simulate multivariate Bernoulli
    distributions.
LazyData: yes
Depends: cmm, Rsolnp, numDeriv, R(>= 2.10.0)
License: GPL-2
URL: https://github.com/jojo-/mipfp
NeedsCompilation: no
Packaged: 2026-08-22 05:43:47 UTC; johan
Repository: CRAN
Date/Publication: 2026-08-22 06:30:02 UTC

exportPattern("^[[:alpha:]]+")
importFrom(cmm,MarginalMatrix)
importFrom(Rsolnp,solnp)
importFrom(numDeriv,jacobian)
importFrom(stats,qnorm,rmultinom)
importFrom(utils,tail)
importFrom("stats", "coef", "pchisq", "printCoefmat", "pt", "vcov")
S3method(coef, mipfp)
S3method(confint, mipfp)
S3method(error.margins, default)
S3method(error.margins, mipfp)
S3method(flat, default)
S3method(flat, array)
S3method(flat, matrix)
S3method(flat, table)
S3method(expand, default)
S3method(expand, table)
S3method(gof.estimates, default)
S3method(gof.estimates, mipfp)
S3method(print, mipfp)
S3method(print, summary.mipfp)
S3method(summary, mipfp)
S3method(vcov, mipfp)

# File mipfp/R/models.R
# by Johan Barthelemy and Thomas Suesse
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 or 3 of the License
#  (at your option).
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/

# ------------------------------------------------------------------------------
# This file provides a function to estimate a contingency table using several
# model-based approaches.
# ------------------------------------------------------------------------------

ObtainModelEstimates <- function(seed, target.list, target.data, method = "ml", 
                                 tol.margins = 1e-10, 
                                 replace.zeros = 1e-10, ...) {
  # Estimates N-way tables using max likelihood, min chi2 or least squares.
  # 
  # This function provides several alternative estimating methods to the IPFP 
  # when estimating multiway table subject to known constrains/totals: Maximum 
  # likelihood method (ML), minimum chi-squared (CHI2) and weighted least 
  # squares (LSQ).
  # 
  # Author: T. Suesse - modified by J. Barthelemy
  #  
  # Args:
  #   seed: The initial multi-dimensional array to be updated. Each cell must 
  #         be non-negative.
  #   target.list: A list of the target margins provided in target.data. Each 
  #                component of the list is an array whose cells indicates which
  #                dimension the corresponding margin relates to.
  #   target.data: A list containing the data of the target margins. Each 
  #                component of the list is an array storing a margin. The list 
  #                order must follow the one defined in target.list. Note that 
  #                the cells of the arrays must be non-negative.
  #   method: by default "ml" (Maximum likelihood), other options "chi2" (
  #           minimum chi-squared) and "lsq" (least squares).
  #   replace.zeros: constant that is added to zero cell counts, as the 
  #                  procedures require strictly positive cell counts.
  #   tol.margins: The tolerance for margins consistency.
  #   ...: Additional parameters that can be passed to control the optimisation
  #        process.
  #     
  # Returns: A mipfp object consisting of a list whose elements are
  #   call: A call object in which all the specified arguments are given by
  #         their full names.
  #   method: The selected method for estimation.
  #   pi.hat: Array of the estimated table probabilities.
  #   xi.hat: Array of the estimated table frequencies.  
  #   error.margins: for each list element of target.data, error.margins shows 
  #                  the maximum absolute value of A * pi.hat - margins.vector.
  #                  The elements should approximate zero, otherwise margins are
  #                  not met.
  #   solnp.res: For optimisation it uses the R package Rsolnp and solnp is the 
  #              corresponding object returned by Rsolnp.
  
  # checking if a seed is provided
  if (is.null(seed) == TRUE) {
    stop('Error: no seed specified!')
  }
  
  # checking if target are provided
  if (is.null(target.data) == TRUE | is.null(target.list) == TRUE) {
    stop('Error: target.data and/or target.list not specified!')
  }
  
  # checking non negativity condition for the seed and the target
  if (min(sapply(target.data, min)) < 0.0 | min(seed) < 0.0) {
    stop('Error: Target and Seed cells must be non-negative!')    
  }
  
  # checking if NA in target cells
  if (is.na(min(sapply(target.data, min))) == TRUE)  {
    stop('Error: NA values present in the margins')
  }
  
  # checking if NA in seed
  if (is.na(min(seed)) == TRUE) {
    stop('Error: NA values present in the seed!')
  }
  
  # checking the strict positivy of replace.zeros
  if (replace.zeros <= 0.0) {
    stop('Error: replace.zeros must be strictly positive!')
  }
  
  # checking the margins consistency if no missing values in the targets
  error.margins <- TRUE
  if (length(target.data) > 1) {
    for (m in 2:length(target.data)) {      
      if (abs(sum(target.data[[m-1]]) - sum(target.data[[m]])) > tol.margins) {   
        error.margins <- FALSE
        warning('Target not consistents - shifting to probabilities!
                  Check input data!\n')
        break  
      }      
    }
  }

  # if margins are not consistent, shifting from frequencies to probabilities
  if (error.margins == FALSE) {
    seed <- seed / sum(seed)
    for (m in 1:length(target.data)) {
      target.data[[m]] <- target.data[[m]] / sum(target.data[[m]])
    }
  }  
  
  # create vector version of the seed compatible with the function 
  # 'MarginalMatrix' from cmm that requires that the last index moves fastest
  seed.vector <- Array2Vector(seed)
    
  # dimensions of the problem
  n.sets.margins <- length(target.list)    
  K <- dim(seed)
  K.length <- length(K)
  K.prod <- prod(K)
  n <- sum(seed.vector)
  target.n = sum(target.data[[1]])
  
  # scaling input to probabilities and removing 0 cells
  seed.vector[seed.vector == 0] <- replace.zeros * n
  seed.prop.vector <- seed.vector / n  
        
  # generation of the constraints matrix A such that A' * pi.hat = target.data
  marg.list <- ComputeA(dim.arr = dim(seed), target.data = target.data, 
                        target.list = target.list)
  A <- t(marg.list$marginal.matrix)
  margins.vector <- marg.list$margins
  dim.A <- dim(A)
  
  # defining some functions used by the optimisation
  # ... log-likelihood function
  fun.loglik <- function(p) {
    return(- sum(seed.vector * log(p)))
  }
  
  # ... chi-square function
  fun.chisq <- function(p) {
    return(sum((p - seed.prop.vector)^2 / p))
  }
  
  # ... least-square function
  fun.lsq <- function(p) {
    return(sum((p - seed.prop.vector)^2 / seed.prop.vector))
  }
  
  # ... equality constraints
  eqfun1 <- function(p) {    
    return(A %*% p - margins.vector)
  }
  
  # switching to the desired user method
  # ... converting method to a integer index
  method.num <- switch(method, ml = 1, chi2 = 2, lsq = 3, 4)
  if (method.num == 4) {
    warning("'method' must be 'ml', 'chi2' or 'lsq', switching to 'ml'!")
    method.num <- 1
    method <- "ml"
  }
  # ... index determine the method: 1 = ML, 2 = CHI2 and 3 = LSQ
  switch(method.num,
    fun <- fun.loglik,
    fun <- fun.chisq,
    fun <- fun.lsq
  )
  
  # calling of "solnp" of package "Rsolnp"
  rsolnp <- try(Rsolnp::solnp(pars=seed.prop.vector, fun = fun,
                              LB = rep(0 + replace.zeros^1.5, K.prod), 
                              UB = rep(1 - replace.zeros^1.5, K.prod), 
                              eqfun = eqfun1, eqB = c(rep(0, dim(A)[1])),                              
                              control = list(trace = 0, ...)))
  
  # assessing solnp's convergence, returning an error if no convergence
  conv <- TRUE
  if (inherits(rsolnp, "try-error") | rsolnp$convergence > 0 ){
    conv <- FALSE
    warning("No reliable solutions found by solnp!
            Check the delta and tol parameters.
            replace.zeros might be too low!\n")
  }
    
  # saving solution: probabilities and frequencies
  pi.hat <- rsolnp$pars
  pi.hat.array <- Vector2Array(pi.hat, dim.out = K)  
  xi.hat.array <- pi.hat.array * target.n
  
  # copying the names and dimnames
  names(pi.hat.array) <- names(seed)
  names(xi.hat.array) <- names(seed)
  dimnames(pi.hat.array) <- dimnames(seed)
  dimnames(xi.hat.array) <- dimnames(seed)
  
  # computing final max difference between generated and target margins
  error.margins <- vector(mode = "numeric", length = n.sets.margins)  
  for (j in 1:n.sets.margins) {
    error.margins[j] = max(abs(target.data[[j]] 
                          - apply(xi.hat.array, target.list[[j]], sum)))
    if (is.null(names(dimnames(seed))) == FALSE) {
      names(error.margins)[j] <- paste(names(dimnames(seed))[target.list[[j]]],
                                       collapse = ".")  
    }
  }      
  
  # gathering the results
  results <- list("x.hat" = xi.hat.array, "p.hat" = pi.hat.array,
                  "error.margins" = error.margins, "solnp.res" = rsolnp,
                  "conv" = conv)  

  # adding the method applied
  results$method <- method
  
  # adding the calling expression
  results$call <- match.call()
  
  # updating the class attribute  
  class(results) <- c("list", "mipfp")
  
  # returning results
  return(results)

}

# File mipfp/R/utils.R
# by Johan Barthelemy and Thomas Suesse
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 or 3 of the License
#  (at your option).
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/

# ------------------------------------------------------------------------------
# This file provides:
# - functions to convert array to vectors and conversely;
# - a function to remove the linearly dependent columns from a given matrix;
# - a function to compute the Wald confidence interval for the estimates
#   generated by either Ipfp or ObtainModelEstimates;
# - a function to compare the deviations between given targets or a table of a
#   a list of mipfp objects;
# - a S3 method to flatten a multidimensional array.
# ------------------------------------------------------------------------------

Array2Vector <- function(arr) {
  # Transform a N-dimensional array a to vector, where last index moves fastest.
  #
  # Author: T. Suesse
  #
  # Args:
  #   arr: The array to be transformed into a vector.
  #
  # Returns: A vector containing the input array data.
  
  # checking if an input array is specified
  if (is.null(arr) == TRUE) {
    stop('Error: no array arr specified!')
  }
  
  dim.array <- dim(arr)
  if (is.null(dim.array) == FALSE ) {
    arr <- aperm(arr, seq(length(dim.array), 1, by = -1))    
  }
  return(c(arr))
  
}

Vector2Array <- function(vect, dim.out) {
  # Transform a vector to an array with given dimensions, where last index moves 
  # fastest.
  #
  # Author: T. Suesse
  #
  # Args:
  #   vector: The vector to be transformed into an array.
  #   dim.out: The dimension of the generated array.
  #
  # Returns: An array filled with the input vector data.
  
  # checking if an input array is specified
  if (is.null(vect) == TRUE) {
    stop('Error: no vector vect specified!')
  }
  
  # checking if an input array is specified
  if (is.null(dim.out) == TRUE) {
    stop('Error: no dimension dim.out specified for the output array!')
  }
  
  l.dim.out<-length(dim.out)
  arr <- array(vect, dim.out[seq(l.dim.out,1,by=-1)])
  arr <- aperm(arr, seq(l.dim.out, 1, by = -1)) 
  return(arr)
  
}

GetLinInd <- function(mat, tol = 1e-10) {
  # Removing the linearly dependant columns of matrix to obtain a matrix of full
  # rank using QR decomposition. See Matrix Computations from Golub and Van Loan
  # (2012) for a detailed description of the procedure.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   mat: The matrix possibly containing linearly dependant columns.
  #   tol: Rank estimation tolerance.
  #
  # Returns: The extracted columns of mat.
  
  # checking if an input matrix is specified
  if (is.null(mat) == TRUE) {
    stop('Error: mat is missing!')
  }
  
  # checking if tol is positive
  if (tol < 0.0) {
    stop('Error: tol must be positive!')
  }
  
  # QR decomposition
  mat.li <- as.matrix(mat)
  mat.qr = qr(mat.li)
  
  # if input matrix is of full rank, nothing to do
  if( mat.qr$rank == dim(mat.li)[2] ) {
    idx = seq(1,dim(mat.li)[2])
    result = list("mat.li" = mat.li, "idx" = idx)
    return(result) 
  }
  
  if( is.vector(qr.R(mat.qr)) == FALSE ) {
    diagr = abs(diag(qr.R(mat.qr)))
  } else {
    diagr = qr.R(mat.qr)[1]
  }
  
  # rank computation
  r = tail(which(diagr >= tol * diagr[1]), n = 1)
  
  # selection the r linearly independant columns
  idx <- sort(mat.qr$pivot[1:r])
  mat.li <- mat.li[,idx]  
  
  # returning the matrix and the selected row indices
  result = list("mat.li" = mat.li, "idx" = idx)
  return(result)
  
}

CompareMaxDev <- function(list.mipfp = list(), true.table = NULL, 
                          echo = FALSE) {
  # This function compares either the margins errors from different
  # mipfp objects or the absolute maximum deviation between a given table
  # and the estimates in the mipfp objects.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   list.mipfp: The list produced by Estimate().
  #   true.table: The table which is compared agains the estimates given by
  #               the mipfp objects in the list.
  #   echo: Verbose parameter. If TRUE print what is being compared.
  #
  # Returns: A table with as many rows as the number of mipfp objects in
  #          list.mipfp. Each row details the margins errors or the 
  #          maximum absolute deviation of one mipfp object.
  
  if (length(list.mipfp) < 1) {
    stop('Error: list.mipfp is empty!
         It must contain at least one mipfp object.')
  }   
  
  tab <- array(0, dim=c(0))
  method.list <- list()
    
  for (i in 1:length(list.mipfp)) {          
    # check class of the current object
    if (any(class(list.mipfp[[i]]) == "mipfp") == FALSE) {
      stop('Error: element ', i, ' of list.mipfp is not a mipfp object!')
    }
    # if no true table has been provided: comparison of the margins errors
    # else computation of the deviation between the estimates and the table
    if (is.null(true.table) == TRUE) {
      tab <- rbind(tab, summary(list.mipfp[[i]])$error.margins)    
    }     
    else {
      max.dev <- max(abs(true.table - list.mipfp[[i]]$x.hat))
      max.dev.p <- max(abs(true.table / sum(true.table) - 
                             list.mipfp[[i]]$p.hat))
      
      tab <- rbind(tab,cbind("Deviation"=max.dev, "Prop"=max.dev.p))
    }    
    method.list <- append(method.list, list.mipfp[[i]]$method)
  }          
  
  # verbosity
  if (echo == TRUE && is.null(true.table) == TRUE) {
    cat('Maximum absolute deviation between targets and generated margins:\n')    
  }
  if (echo == TRUE && is.null(true.table) == FALSE) {
    cat('Maximum absolute deviation:\n')    
  }
  
  rownames(tab) <- method.list
  return(tab)
  
}

flat <- function(x, ...) {
  # Generic method to flatten its argument.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   x: An object to be flattened.
  #   ...: Further arguments passed to or from other methods.
  
  UseMethod("flat", x)
  
}

flat.default <- function(x, ...) {
  # Default method of the genereric flat function. A specific method to
  # flatten the argument has not been implemented yet and the method returns
  # the original object.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   x: An object.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: The original, unmodified object.
  
  warning('Can not flatten this object!')
  return(x)
  
}

flat.array <- function(x, sep = ".", label = "value", l.names = 0, ...) {  
  # This function takes a multidimensional array and flattens it to a 
  # 2-dimension for a pretty printing. The row names are the concatenation
  # of the original dimension names while the only column stores the initial
  # data of the array.
  # Note: The function is inspired from the function wrap.array from the
  #       package R.utils written by Henrik Bengtsson.
  #
  # Author: J. Barthelemy (inspired by H. Bengtsson)
  #
  # Args:
  #   x: An array.
  #   sep: The separator used to concatenate the dimension names.
  #   label: The name of the column storing the data.
  #   lnames: If > 0, set the max lenght of the dimnames, otherwise keeps
  #           the original dimnames.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: An array containing a flattened version of x
  
  # testing if input is not NULL
  if (is.null(x) == TRUE) {
    stop('Error: input x is NULL!')
  }
  
  # getting some useful information
  n.dim <- length(dim(x))  
  dimnames.temp <- dimnames(x)    
  
  # generating default names if dimnames(x) is NULL
  if (is.null(dimnames.temp) == TRUE) {
    for (d in seq(1,n.dim)) {
      dimnames.temp[[d]] <- seq(1,dim(x)[d])
      names(dimnames.temp)[d] <- paste0("V",d)
    }
  }
  
  # flattening the array to one dimension
  dim(x) <- c(prod(dim(x)),1)   
  
  # concatening the dimensions names    
  dims.rename <- function(dims) {    
    d.names <- NULL
    for (d in dims) {
      d.names.tmp <- dimnames.temp[[d]]
      if (l.names > 0) {
        d.names.tmp <- substr(d.names.tmp, 1, l.names)
      }
      if (is.null(d.names)) {
        d.names <- d.names.tmp
      }
      else {        
        d.names <- paste(d.names, 
                         rep(d.names.tmp, each = length(d.names)), 
                         sep = sep)
      }      
    }
    return(d.names)
  }
  
  # updating the dimnames
  dimnames(x) <- c(lapply(list(seq(1,n.dim)), dims.rename), label)
  concat.names <- paste(names(dimnames.temp),collapse = sep)
  names(dimnames(x)) <- c(concat.names,"")
  
  return(x)
  
}

flat.table <- function(x, sep = ".", label = "value", l.names = 0, ...) {
  # This function takes a multidimensional table and flattens it to a 
  # 2-dimension for a pretty printing. The row names are the concatenation
  # of the original dimension names while the only column stores the initial
  # data of the array.
  # Note: The function is inspired from the function wrap.array from the
  #       package R.utils written by Henrik Bengtsson.
  #
  # Author: J. Barthelemy (inspired by H. Bengtsson)
  #
  # Args:
  #   x: A table.
  #   sep: The separator used to concatenate the dimension names.
  #   label: The name of the column storing the data.
  #   lnames: If > 0, set the max lenght of the dimnames, otherwise keeps
  #                 the original dimnames.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: An array containing a flattened version of x
  
  return(flat.array(x, sep = sep, label = label, l.names = l.names, ...))
  
}

flat.matrix  <- function(x, sep = ".", label = "value", l.names = 0, ...) {
  # This function takes a matrix and flattens it to a 
  # 2-dimension for a pretty printing. The row names are the concatenation
  # of the original dimension names while the only column stores the initial
  # data of the array.
  # Note: The function is inspired from the function wrap.array from the
  #       package R.utils written by Henrik Bengtsson.
  #
  # Author: J. Barthelemy (inspired by H. Bengtsson)
  #
  # Args:
  #   x: A matrix.
  #   sep: The separator used to concatenate the dimension names.
  #   label: The name of the column storing the data.
  #   lnames: If > 0, set the max lenght of the dimnames, otherwise keeps
  #                 the original dimnames.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: An array containing a flattened version of x
  
  return(flat.array(x, sep = sep, label = label, l.names = l.names, ...))
  
}

expand <- function(x, ...) {
  # Generic method to expand its into a data frame.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   x: An object to be expanded.
  #   ...: Further arguments passed to or from other methods.
  
  UseMethod("expand", x)
  
}

expand.default <- function(x, ...) {
  # Default method of the genereric expand function. A specific method to
  # expand the argument into a data frame has not been implemented yet and the 
  # method returns the original object.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   x: An object.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: The original, unmodified object.
  
  warning('Can not expand this object into a data frame!')
  return(x)
  
}

expand.table <- function(x, ...) {
  # This function takes a multi-dimensionnal contingency table and expands it 
  # to a data frame containing individual records.
  # Note: The function is inspired from the "Cookbook for R" available at
  # http://www.cookbook-r.com/Manipulating_data/Converting_between_data_frames
  # _and_contingency_tables/
  #
  # Author: J. Barthelemy (inspired by Winston Chang)
  #
  # Args: 
  #   x: A table x.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: A data frame of the individual records derived from x.
  
  # check if the rounded table summed to at least 1, otherwise stops
  if (sum(x) <= 1) {
    stop("The sum of the element of x should be at least 1!")
  }
  
  # coercing x to a data frame
  x.df <- as.data.frame(round(x), ...)
  
  # getting the number of time each row must be replicated
  idx <- rep.int(seq_len(nrow(x.df)), x.df$Freq)
  
  # drop count column
  x.df$Freq <- NULL
  
  # get the rows from result using idx
  result <- x.df[idx, ]
  
  # renaming the row names
  row.names(result) <- 1:dim(result)[1]
  
  # returning the result
  return(result)
  
}

ComputeA <- function(dim.arr, target.list, target.data) {
  # Given two vector x and and a set of target constraints, returns the marginal
  # matrix A and vector t derived from the targets such that A' * x = t.
  #
  # Note that x and t are obtained by removing the first element of
  # each target in order for A to be full rank.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   dim.arr: dimension of the problem, i.e. of the array
  #   target.list: A list of the target margins provided in target.data. Each 
  #                component of the list is an array whose cells indicates which
  #                dimension the corresponding margin relates to.
  #   target.data: A list containing the data of the target margins. Each 
  #                component of the list is an array storing a margin. The list 
  #                order must follow the one defined in target.list. Note that 
  #                the cells of the arrays must be non-negative.
  #
  # Returns: A list whose elements are:
  #   marginal.matrix: The marginal matrix.
  #   margins: A vector containing the margins associated with A.
  #   df: The degree of freedom of the problem.
  
  # checking if a seed is provided
  if (is.null(dim.arr) == TRUE) {
    stop('Error: dimension of the seed not provided!')
  }
  
  # checking if target.list is provided 
  if (is.null(target.list) == TRUE) {
    stop('Error: target.list not provided!')
  }
  
  # checking if target.data is provided
  if (is.null(target.data) == TRUE) {
    stop('Error: target.data not provided!')
  }
  
  # checking if NA in target cells
  if (is.na(min(sapply(target.data, min))) == TRUE)  {
    stop('Error: NA values present for margins contained in target.data!')
  }
  
  # generating some useful variables
  n.cells <- prod(dim.arr)
  
  # generating A such that A' * pi = target.data
  margins.vector <- c(1)
  A.t <- matrix(1, nrow = 1, ncol = n.cells)
  # ... generating the marginal matrix row by row
  
  for (k in 1:length(target.list)) {
    
    # convert k-th margin to an array
    temp.margins <- Array2Vector(target.data[[k]])
    
    # remove first condition as it is redundant information
    temp.margins <- temp.margins[-1] / sum(temp.margins)
    margins.vector <- c(margins.vector, temp.margins)
    
    # construct the current row of the marginal matrix
    A.row <- cmm::MarginalMatrix(var = 1:length(dim.arr), 
                                 marg = target.list[[k]], 
                                 dim = dim.arr)[-1, ]
    
    # remove first entry as it is always redundant
    A.t <- rbind(A.t, A.row)      
    
  }
  A.li <- GetLinInd(t(A.t))
  A <- A.li$mat.li
  margins.vector <- margins.vector[A.li$idx]
  
  # degrees of freedom of the estimates
  deg.free <- dim(A)[1] - dim(A)[2] 
  
  # gathering the results and return
  results <- list("marginal.matrix" = A, "margins" = margins.vector,
                  "df" = deg.free)
  return(results)
  
}

# File mipfp/R/s3_mipfp.R
# by Johan Barthelemy and Thomas Suesse
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 or 3 of the License
#  (at your option).
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/

# ------------------------------------------------------------------------------
# This file provides S3 methods for mipfp objects, including a constructor,
# print, summary, error.margins and confint.
# ------------------------------------------------------------------------------

coef.mipfp <- function(object, prop = FALSE, ...) {
  # S3 function which extracts estimates from mipfp objects.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   object: The mipfp object whose estimates should be retrieved.
  #   prop: If set to TRUE the probabilities are retrieved, otherwise the counts
  #         will be considered (default: FALSE).
  #   ...: Not used.
  #
  # Returns: Estimates extracted from the mipfp object object.

  # checking whether the user wants probabilities or counts
  if (prop == TRUE) {
    tab <- flat(object$p.hat, label = "Probability")
  } else {
    tab <- flat(object$x.hat, label = "Estimate")
  }

  # creating and returning the resulting vector
  result <- as.vector(tab)
  names(result) <- rownames(tab)
  return(result)

}

print.mipfp <- function(x, prop = FALSE, ...) {
  # S3 print method for class mipfp. This method prints a brief description
  # of the input argument.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   x: The mipfp object to be printed.
  #   prop: Indicates whether the print shows counts (FALSE) or probabilities
  #         (TRUE).
  #   ...: Further arguments passed to or from other methods.

  cat("\nCall:\n")
  print(x$call)
  cat("\nMethod: ", x$method,"- convergence: ", x$conv, "\n")
  cat("\nEstimates:\n")

  if (prop == TRUE) {
    x <- x$p.hat
    lab <- "Probability"
  } else {
    x <- x$x.hat
    lab <- "Estimate"
  }

  if (length(dim(x)) < 3 ) {
    print(x, ...)
  } else {
    print(flat(x, label = lab, ...), ...)
  }

  invisible(x)

}

summary.mipfp <- function(object, cov.method = "delta", prop = FALSE,
                          target.list = NULL, l.names = 0, ...) {
  # S3 summary method for class mipfp. This method returns a summary object
  # containing various information about the estimates contained in the
  # firts argument.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   object: The mipfp object to be summarized.
  #   cov.method: Indicates which method to use to compute the covariance.
  #               Possible values are Delta ('delta', default) or Lang ('lang').
  #   prop: Indicate whether the results should return counts or probabilities.
  #   target.list: The list of the dimensions of the targets used by the
  #                estimation process
  #   ...: Further arguments passed to or from other methods
  #
  # Returns: An object of class summary.mipfp whose elements are
  #   call: A call object in which all the specified arguments are given by
  #         their full names.
  #   conv: A boolean indicating if the specified method converged to a
  #         solution (TRUE) or not (FALSE)
  #   method: The method used to generate estimates.
  #   df: Degrees of freedom of the estimates.
  #   estimates: Estimates generated by the selected method with
  #              standard deviations and associated t- and p-values.
  #   error.margins: A list returning, for each margin, the absolute maximum
  #                  deviation between the desired and generated margin.
  #   vcov: A covariance matrix of the estimates (last index move fastest).
  #   stats.df:  Degrees of freedom for the G2, W2 and X2 statistics
  #   tab.gof: A table containing the G2, W2 and X2 statistics with their
  #            associated p-values.
  #   stats.gof: G2, W2 and X2 statistics.
  #   dim.names: original dimension names of the estimated table.

  # gathering some initial data
  results <- list("call" = object$call,
                  "conv" = object$conv,
                  "method" = object$method,
                  "dim.names" = dimnames(object$x.hat),
                  "l.names" = l.names)

  # checking whether the user wants probabilities or counts
  if (prop == TRUE) {
    tab <- flat(object$p.hat, label = "Probability", l.names = l.names, ...)
  } else {
    tab <- flat(object$x.hat, label = "Estimate", l.names = l.names, ...)
  }

  # computing covariance matrix
  cov.results <- vcov(object, method.cov = cov.method, prop = prop, ...)
  if (prop == FALSE){
    results$vcov <- cov.results$x.hat.cov
  } else {
    results$vcov <- cov.results$p.hat.cov
  }

  # degrees of freedom
  results$df <- cov.results$df

  # getting the estimates, their standard deviation and p-values
  if (prop == TRUE) {
    std.dev.arr <- Vector2Array(cov.results$p.hat.se, dim(object$p.hat))
  } else {
    std.dev.arr <- Vector2Array(cov.results$x.hat.se, dim(object$p.hat))
  }
  std.dev <- flat(std.dev.arr, label = "StdDev")
  tval <- tab / std.dev
  dimnames(tval)[2] <- "t.value"
  pval <- 2 * pt(-abs(tval), df = results$df)
  dimnames(pval)[2] <- "p.value"
  tab <- cbind(tab, StdDev = std.dev, t.value = tval, p.value = pval)
  results$estimates <- tab

  # margins errors
  # ... checking if target.list is provided
  if (is.null(target.list) == TRUE) {
    if (is.null(object$target.list) == TRUE) {
      target.list <- eval(object$call$target.list, parent.frame(2))
    } else {
      target.list <- object$target.list
    }
  }

  # ... retrieving / generatings names
  if (is.null(names(object$error.margins)) == TRUE) {
    for (d in 1:length(target.list)) {
      if (is.null(names(target.list[[d]])) == TRUE) {
        names(object$error.margins)[d] <- paste0("V",target.list[[d]],
                                                 collapse = ".")
      } else {
        names(object$error.margins)[d] <- paste0(names(target.list[[d]]),
                                                 collapse = ".")
      }
    }
  }
  # ... retrieving the errors
  results$error.margins <- object$error.margins

  # gathering the goodness of fit statistics
  gof.results <- gof.estimates(object, ...)
  df.gof <- gof.results$stats.df
  tab.gof <- rbind(G2 = c(gof.results$G2, 1 - pchisq(gof.results$G2,
                                                     df = df.gof)),
                   W2 = c(gof.results$W2, 1 - pchisq(gof.results$W2,
                                                     df = df.gof)),
                   X2 = c(gof.results$X2, 1 - pchisq(gof.results$X2,
                                                     df = df.gof)))
  dimnames(tab.gof)[[2]] <- c("Stat","p.value")
  results$stats.df <- df.gof
  results$stats.gof <- tab.gof

  # returning the results
  class(results) <- "summary.mipfp"
  return(results)

}

print.summary.mipfp <- function(x, ...) {
  # S3 print method for class mipfp. This method prints a brief description
  # of the input argument.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   x: The summary.mipfp object to be printed.
  #   ...: Further arguments passed to or from other methods.

  cat("\nCall:\n")
  print(x$call)
  cat("\nMethod:", x$method," - convergence:", x$conv, "\n\n")

  printCoefmat(x$estimates, P.values = TRUE, has.Pvalue = TRUE)
  cat("Degrees of freedom:", x$df,"\n")

  # printing the levels of the variables
  cat("\nVariables:\n")
  dn <- x$dim.names
  if (is.null(dn) == FALSE) {
    for (i in 1:length(x$error.margins)) {
      #cat("*", names(dn[i]),":", dn[[i]], "\n")
      cat("*", names(dn[i]),":")
      for (j in 1:length(dn[[i]])) {
        cat("",dn[[i]][j])
        if (x$l.names > 0) {
          cat(" (",substr(dn[[i]][j],1, x$l.names),")", sep = "")
        }
      }
      cat("\n")
    }
  }

  # margins errors
  cat("\nMargins errors:\n")
  print(x$error.margins, ...)

  # goodness of fit statistics
  cat("\nGoodness of fit statistics:\n")
  printCoefmat(x$stats.gof, P.values = TRUE, has.Pvalue = TRUE)
  cat("Degrees of freedom:", x$stats.df,"\n\n")

  invisible(x)

}

error.margins <- function(object, ...) {
  # Generic method to compute the margins errors its argument. The error
  # is defined as the deviation between the expected (true) and resulting
  # margins.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   x: An object to be flattened.
  #   ...: Further arguments passed to or from other methods.

  UseMethod("error.margins", object)

}

error.margins.default <- function(object, ...) {
  # Default method to compute the margins errors its argument. The error
  # is defined as the deviation between the expected (true) and resulting
  # margins.  A specific method has not been implemented yet and the method
  # returns the original object.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   x: An object.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: The original, unmodified object.

  warning('The input argument is not an object of class mipfp!')
  invisible(object)

}

error.margins.mipfp <- function(object, ...) {
  # S3 error.margins method for class mipfp.
  #
  # This method returns the maximum deviation between each generated and
  # desired margins of the input argument. It corresponds to the absolute
  # maximum deviation between each target margin used to generate the estimates
  # in the mipfp object and the generated one.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   object: The summary.mipfp object to be printed.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: An array containing the absolute maximum deviations for each
  #          margin.

  res <- CompareMaxDev(list(object), echo = FALSE, ...)
  return(res)

}

confint.mipfp <- function(object, parm, level = 0.95, prop = FALSE, ...) {
  # S3 confint method for class mipfp.
  #
  # This methods returns the confidence intervals for the estimates in the
  # mipfp object provided that the covariance of the estimates have also been
  # estimated.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   object: The mipfp object containing the estimates
  #   level: The confidence level
  #   prop: A boolean indicating if the results should be using counts (FALSE)
  #         or proportion (TRUE). Default is FALSE.
  #   ...: Further arguments passed to or from other methods (for instance
  #        vcov.mipf).
  #
  # Returns: The confidence intervals of the estimates in object in an array.

  # checking significance level alpha
  alpha <- 1 - level
  if (alpha < 0 || alpha > 1) {
    warning('Warning: alpha not in the range [0,1], setting to 0.05!')
    alpha <- 0.05
  }

  # getting the estimates and their standart deviation
  x <- coef(object, prop = prop, ...)
  if (prop == FALSE) {
    x.se <- vcov(object, prop = prop, ...)$x.hat.se
  } else {
    x.se <- vcov(object, prop = prop, ...)$p.hat.se
  }

  # selection of the estimates
  pnames <- names(x)
  if (missing(parm)) {
    parm <- pnames
  }
  else if (is.numeric(parm)) {
    parm <- pnames[parm]
  }

  # computing the confidence interval for the selected estimates
  l <- qnorm(1 - alpha * 0.5)
  label.up <- paste0((1 - alpha * 0.5) * 100, "%")
  label.lo <- paste0((alpha * 0.5) * 100, "%")
  ci.lo <- x[parm] - l * x.se[parm]
  ci.up <- x[parm] + l * x.se[parm]

  # returning the result
  ci <- cbind(ci.lo, ci.up)
  dimnames(ci)[[2]] <- c(label.lo, label.up)
  return(ci)

}

vcov.mipfp <- function(object, method.cov = "delta", seed = NULL,
                       target.data = NULL, target.list = NULL,
                       replace.zeros = 1e-10, ...) {
  # Compute the covariance matrix of the estimators produced by Estimate.
  #
  # This function determines the covariance matrix of the estimated proportions
  # using either
  # - the Delta given in the paper "Models for Contingency Tables With Known
  #   Margins When Target and Sampled Populations Differ" written by Little and
  #   Wu (1991). This is the default.
  # - the Lang method in "Multinomial-Poisson homogeneous models for contingency
  #   tables".
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   object: an object of class mipfp.
  #   seed: The initial multi-dimensional array updated by Estimate (optional).
  #   target.list: A list of the target margins used by the Ipfp function. Each
  #                component of the list is an array whose cells indicates
  #                which dimension the corresponding margin relates to
  #                (optional).
  #   target.data: A list containing the data of the target margins. Each
  #                component of the list is an array storing a margin.
  #                The list order must follow the one defined in target.list.
  #                Note that the cells of the arrays must be non-negative
  #                (optional).
  #   replace.zeros: If 0-cells are to be found in either the seed or the
  #                  estimate arrays, then their values are replaced with this
  #                  value.
  #   method.cov: Select the method to use for the computation of the covariance.
  #               The available methods are Delta and Lang.
  #   ...: Not used.
  #
  # Returns: A list whose elements are
  #   x.hat.cov: A covariance matrix of the estimated probabilities (last index
  #              move fastest).
  #   p.hat.cov: A covariance matrix of the estimated probabilities (last index
  #              move fastest).
  #   x.hat.se: A covariance matrix of the estimated probabilities (last index
  #             move fastest).
  #   p.hat.se: A covariance matrix of the estimated probabilities (last index
  #             move fastest).
  #   df: The degrees of freedom of the estimates.
  #   method.cov: The method used to compute the covariance matrix.

  # checking if a seed is provided
  if (is.null(seed) == TRUE) {
    if (is.null(object$seed)) {
      seed <- eval(object$call$seed, parent.frame(2), parent.frame(2))
    } else {
      seed <- object$seed
    }
  }

  # checking if target.list is provided
  if (is.null(target.list) == TRUE) {
    if (is.null(object$target.list) == TRUE) {
      target.list <- eval(object$call$target.list, parent.frame(2))
    } else {
      target.list <- object$target.list
    }
  }

  # checking if target.data is provided
  if (is.null(target.data) == TRUE) {
    if (is.null(object$target.data) == TRUE) {
      target.data <- eval(object$call$target.data, parent.frame(2))
    } else {
      target.data <- object$target.data
    }
  }

  # checking if NA in target cells
  if (is.na(min(sapply(target.data, min))) == TRUE)  {
    stop('Error: NA values present for margins contained in target.data!')
  }

  # selection the method for the covariance computation
  method.num <- switch(method.cov, delta = 1, Lang = 2, 3)
  if (method.num == 3) {
    warning("'method must be 'delta' or 'Lang'! Switching to 'delta'")
    method.cov <- "delta"
  }

  # determining the estimation method used
  method.mipfp.num <- switch(object$method, ipfp = 1, ml = 2, chi2 = 3, lsq = 4)

  # generating some useful variables
  n <- sum(seed)
  seed.prob <- Array2Vector(seed / sum(seed))
  estimate.prob <- Array2Vector(object$p.hat)

  # checking for 0-cells values and replace them with a small value
  seed.prob <- ifelse(seed.prob == 0, replace.zeros, seed.prob)
  estimate.prob <- ifelse(estimate.prob == 0, replace.zeros, estimate.prob)

  # compute marginal matrix A such that A' * x = margins if not given
  marg.list <- ComputeA(dim.arr = dim(seed), target.data = target.data,
                        target.list = target.list)
  A <- marg.list$marginal.matrix
  margins.vector <- marg.list$margins

  # degrees of freedom of the estimates
  deg.free <- dim(A)[1] - dim(A)[2]

  # Delta method
  if (method.num == 1) {

    # ... generating inv(D1) and inv(D2)
    switch(method.mipfp.num, {
      # ipfp
      D1.inv <- diag(1 / estimate.prob)
      D2.inv <- diag(1 / seed.prob)
    }, {
      # ml
      D1.inv <- diag(1 / (estimate.prob^2 / seed.prob))
      D2.inv <- D1.inv
    }, {
      # chi2
      D1.inv <- diag(1 / (estimate.prob^4 / seed.prob^3))
      D2.inv <- D1.inv
    }, {
      # lsq
      D1.inv <- diag(1 / seed.prob)
      D2.inv <- diag(1 / (seed.prob^3 / estimate.prob^2))
    })

    # ... obtain orthogonal complement of A using QR decomposition
    K <- qr.Q(qr(A), complete = TRUE)[, (dim(A)[2] + 1):dim(A)[1]]
    if (is.null(dim(K)) == TRUE) {
      K <- t(K)
    }
    if (dim(K)[1] == 1) {
      K <- t(K)
    }

    # ... computing the covariance of p.hat
    p.hat.cov <- (1 / n) * K %*% solve(t(K) %*% D1.inv %*% K) %*%
                 t(K) %*% D2.inv %*% K %*% solve(t(K) %*% D1.inv %*% K) %*% t(K)

  }
  # Lang's method
  else {

    # ... constraint function h(pi) = A'[-1] * pi - margins[-1]
    h.fct <- function(m) {
      return(t(A)[-1, ] %*% (m / sum(m)) - margins.vector[-1])
    }

    # ... generating H and D
    H.pi <- t(numDeriv::jacobian(h.fct, estimate.prob))
    D.pi <- diag(estimate.prob)

    # ... computing the covariance
    p.hat.cov <- 1 / n * (D.pi - estimate.prob %*% t(estimate.prob) -
                          D.pi %*% H.pi %*% solve(t(H.pi) %*% D.pi %*% H.pi)
                          %*% t(H.pi) %*% D.pi)

  }

  # adding names
  rownames(p.hat.cov) <- names(coef(object))
  colnames(p.hat.cov) <- names(coef(object))

  # counts' covariance
  x.hat.cov <- p.hat.cov * sum(object$x.hat)^2

  # estimates' standart deviation
  p.hat.se <- sqrt(diag(p.hat.cov))
  x.hat.se <- sqrt(diag(x.hat.cov))

  # gathering and returning the results
  results <- list("p.hat.se" = p.hat.se, "p.hat.cov" = p.hat.cov,
                  "x.hat.se" = x.hat.se, "x.hat.cov" = x.hat.cov,
                  "df" = deg.free, "method.cov" = method.cov)
  return(results)

}

gof.estimates <- function(object, ...) {
  # Generic method to compute the goodness of fit of the estimates.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   object: An object containing estimates.
  #   ...: Further arguments passed to or from other methods.

  UseMethod("gof.estimates", object)

}

gof.estimates.default <- function(object, ...) {
  # Default method of the genereric gof.estimate function. A specific method to
  # compute the goodness of fit statistics has not been implemented yet and the
  # method returns the original object.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   object: An object.
  #   ...: Further arguments passed to or from other methods.
  #
  # Returns: The original object.

  warning('Can not conmpute the covariance of the estimates for this object!')
  invisible(object)

}

gof.estimates.mipfp <- function(object, seed = NULL,
                                target.data = NULL, target.list = NULL,
                                replace.zeros = 1e-10, ...) {
  # This function computes statistics to test wheter the target constraints
  # are met for the estimates contains in an object of class mipfp.
  #
  # Note that if the seed, target.data and target.list are not provided
  # then the function test whether this information is present in the object
  # or can be retrieved from the Estimate call used generate the object.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   object: The object of class mipfp containing the estimates.
  #   seed: The seed used to compute the estimates (optional).
  #   target.data: A list containing the data of the target margins. Each
  #                component of the list is an array storing a margin.
  #                The list order must follow the one defined in target.list.
  #                Note that the cells of the arrays must be non-negative (and
  #                can even be NA if method = ipfp) (optional).
  #   target.list A list of the target margins provided in target.data. Each
  #               component of the list is an array whose cells indicates
  #               which dimension the corresponding margin relates to
  #               (optional).
  #
  # Returns: A list whose elements are:
  #   G2: Log-likelihood statistic.
  #   W2: Wald statistic.
  #   X2: Person chi-squared statistic.
  #   stats.df: Degrees of freedom for the G2, W2 and X2 statistics.

  # checking if a seed is provided
  if (is.null(seed) == TRUE) {
    if (is.null(object$seed)) {
      seed <- eval(object$call$seed, parent.frame(2))
    } else {
      seed <- object$seed
    }
  }

  # checking if target.list is provided
  if (is.null(target.list) == TRUE) {
    if (is.null(object$target.list) == TRUE) {
      target.list <- eval(object$call$target.list, parent.frame(2))
    } else {
      target.list <- object$target.list
    }
  }

  # checking if target.data is provided
  if (is.null(target.data) == TRUE) {
    if (is.null(object$target.data) == TRUE) {
      target.data <- eval(object$call$target.data, parent.frame(2))
    } else {
      target.data <- object$target.data
    }
  }

  # checking if NA in target cells
  if (is.na(min(sapply(target.data, min))) == TRUE)  {
    stop('Error: NA values present for margins contained in target.data!')
  }

  # compute marginal matrix A such that A' * x = margins
  marg.list <- ComputeA(dim.arr = dim(seed), target.data = target.data,
                        target.list = target.list)
  A <- marg.list$marginal.matrix
  margins.vector <- marg.list$margins

  # gather some necessary variables
  n <- sum(seed)
  seed.vector <- Array2Vector(seed)
  seed.vector[seed.vector == 0] <- replace.zeros * n
  seed.prop.vector <- seed.vector / n

  # constraint function h(pi) = A'[-1, ] * pi - margins[-1]
  h.fct <- function(m) {
    return(t(A)[-1, ] %*% (m / sum(m)) - margins.vector[-1])
  }
  H.seed <- t(numDeriv::jacobian(h.fct, seed.vector))
  h.Y <- h.fct(seed.vector)

  # compute statistics for testing if constraints are met and appending to
  # the results
  # ... log-likelihood ratio
  G2 <- 2 * sum(seed.vector * log(seed.prop.vector /
                                  Array2Vector(object$p.hat)))
  # ... Wald test statistic
  W2 <- t(h.Y) %*% solve(t(H.seed) %*% diag(seed.vector) %*% H.seed) %*% h.Y
  # ... Pearson Chi-square
  X2 <- t(seed.vector - n * Array2Vector(object$p.hat)) %*%
        diag(1 / (n * Array2Vector(object$p.hat))) %*%
        (seed.vector - n * Array2Vector(object$p.hat))
  # ... associated degree of freedoms (dim of constraint function h)
  stats.df <- dim(t(A))[1] - 1

  # gathering the results and return
  results <- list("G2" = G2, "W2" = W2, "X2" = X2, "stats.df" = stats.df)
  return(results)

}

Estimate <- function(seed, target.list, target.data, method = "ipfp",
                     keep.input = FALSE, ...) {
  # Update an N-way table given target margins.
  #
  # This function provides several alternative estimating methods to
  # estimate multiway table subject to known constrains/totals: Iterative
  # Proportionnal Fitting Procedure (IPFP),  Maximum Likelihood method (ML),
  # Minimum Chi-squared (CHI2) and Weighted Least squares (LSQ).
  #
  # The covariance matrix of the estimate as well as several other statistics
  # are also computed.
  #
  # As this function is an interface to the functions Ipfp and
  # ObtainModelEstimates, please see their respective documentation for more
  # details.
  #
  # The outcome of the function is an object of class mipfp.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   seed: The initial multi-dimensional array to be updated. Each cell must
  #         be non-negative.
  #   target.list: A list of the target margins provided in target.data. Each
  #                component of the list is an array whose cells indicates
  #                which dimension the corresponding margin relates to.
  #   target.data: A list containing the data of the target margins. Each
  #                component of the list is an array storing a margin.
  #                The list order must follow the one defined in target.list.
  #                Note that the cells of the arrays must be non-negative (and
  #                can even be NA if method = ipfp).
  #   method: The method used for estimation. Possible value are
  #           - "ipfp" (default): iterative proportional fitting procedure
  #           - "ml": maximum likelihood method
  #           - "chi2": minimum chi-squared method
  #           - "lsq": least squares method.
  #   keep.input: If set to TRUE, then the function will add seed, target.data
  #               and target.list to the returned object.
  #   ...: Further arguments passed to or from other methods. See documentation
  #        of Ipfp and ObtainModelEstimate for a list of parameters to control
  #        the estimation process.
  # Returns: A mipfp object consisting of a list whose elements are
  #   call: A call object in which all the specified arguments are given by
  #         their full names.
  #   method: The selected method for estimation.
  #   pi.hat: Array of the estimated table probabilities.
  #   xi.hat: Array of the estimated table frequencies.
  #   stp.crit: The final value of the stopping criterion (if method = ipfp).
  #   evol.stp.crit: Evolution of the stopping criterion over the iterations
  #                  (if method = ipfp).
  #   solnp.res: For optimisation it uses the R package Rsolnp and solnp is the
  #              corresponding object returned by Rsolnp (if method is NOT
  #              ipfp).
  #   conv: A boolean indicating whether the algorithm converged to a solution.
  #   error.margins: A list returning, for each margin, the absolute maximum
  #                  deviation between the target and generated margin.

  # checking if a seed is provided
  if (is.null(seed) == TRUE) {
    stop('Error: no seed specified!')
  }

  # checking if targets are provided
  if (is.null(target.data) == TRUE | is.null(target.list) == TRUE) {
    stop('Error: target.data and/or target.list not specified!')
  }

  # switching to the desired user method
  method.num <- switch(method, ipfp = 1, ml = 2, chi2 = 3, lsq = 4, 5)
  if (method.num == 5) {
    warning("'method' must be 'ipfp', 'ml', 'chi2' or 'lsq', switching to
            'ipfp'!")
    method <- "ipfp"
  }

  # calling the corresponding function to update the seed
  if (method == "ipfp") {
    result <- Ipfp(seed, target.list, target.data, ...)
  } else {
    result <- ObtainModelEstimates(seed, target.list, target.data,
                                   method = method, ...)
  }
  result$call <- match.call()

  # saving the input if required
  if (keep.input == TRUE) {
    result$seed <- seed
    result$target.list <- target.list
    result$target.data <- target.data
  }

  return(result)

}

# File mipfp/R/deprecated.R
# by Johan Barthelemy and Thomas Suesse
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 or 3 of the License
#  (at your option).
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/

# ------------------------------------------------------------------------------
# This file contains the deprecated methods that will be removed in future
# releases of the package.
# ------------------------------------------------------------------------------

IpfpCov <- function(estimate, seed, target.list, replace.zeros = 1e-10) {
  # Compute the covariance matrix of the estimators produced by Ipfp.
  #
  # This function determines the covariance matrix of the estimated proportions
  # using the Delta method given in the paper "Models for Contingency Tables 
  # With Known Margins When Target and Sampled Populations Differ" written by 
  # Little and Wu (1991).
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   estimate: The array of estimate produced by the Ipfp function.
  #   seed: The initial multi-dimensional array updated by Ipfp. 
  #   target.list: A list of the target margins used by the Ipfp function. Each
  #                component of the list is an array whose cells indicates
  #                which dimension the corresponding margin relates to.
  #   replace.zeros: If 0-cells are to be found in either the seed or the
  #                  estimate arrays, then their values are replaced with this
  #                  value.
  #
  # Returns: A list whose elements are  
  #   p.hat.cov: A covariance matrix of the estimated probabilities (last index 
  #              move fastest).
  #   df: Degrees of freedom of the estimates.
  
  n <- sum(seed)  
  seed.prob <- Array2Vector(seed / sum(seed))
  estimate.prob <- Array2Vector(estimate / sum(estimate))
  
  # checking if 0-cells values and replace them with a small value  
  seed.prob <- ifelse(seed.prob == 0, replace.zeros, seed.prob)    
  estimate.prob <- ifelse(estimate.prob == 0, replace.zeros, estimate.prob)
  
  # computation of the diagonal matrix filled with the inverses of seed and
  # estimated probabilities
  D.estimate <- diag(1 / estimate.prob)
  D.seed <- diag(1 / seed.prob)
  
  # computation of A such that A' * vector(estimate) = vector(target.data)
  # ... one line filled with ones
  A.transp <- matrix(1, nrow = 1, ncol = length(estimate.prob))  
  # ... constrainst (removing the first one since it is redundant information)
  for (j in 1:length(target.list)) {
    marg.mat <- cmm::MarginalMatrix(var = 1:length(dim(seed)), 
                                    marg = target.list[[j]], 
                                    dim = dim(seed))[-1, ]
    
    A.transp <- rbind(marg.mat, A.transp)
  }  
  A <- t(A.transp)
  
  # removing the linearly dependant columns from A (redundant constrainst)
  A <- GetLinInd(A)$mat.li
  
  # computation of the orthogonal complement of A (using QR decomposition)
  K <- qr.Q(qr(A), complete = TRUE)[, (dim(A)[2] + 1):dim(A)[1]]
  
  # computation of the variance  
  estimate.var <- (1 / n) * K %*% solve((t(K) %*% D.estimate %*% K)) %*%
    t(K) %*% D.seed %*% K %*%
    solve(t(K) %*% D.estimate %*% K) %*% t(K)   
  
  # returning the result
  return(estimate.var)
  
}

GetConfInt <- function(list.est, alpha = 0.05) {
  # Computing the confidence interval for the estimates produced either
  # by the Ipfp() or ObtainModelEstimates() functions.
  # See confint for a new version of this functionnality.
  #
  # Author: J. Barthelemy
  #
  # Args:
  #   list.est: The list produced by either Ipfp() or ObtainModelEstimates().
  #   alpha: The confidence level.
  #
  # Returns: a list containing the confidence interval of the estimates and
  #          their probabilities
  
  # checking that a list.est is provided
  if (is.null(list.est) == TRUE)  {
    stop('Error: a list containing the estimate and their standard deviation
         is missing!')
  }
  
  # checking that alpha is in [0,1]
  if (alpha < 0.0 | alpha > 1.0) {
    stop('Error: the confidence level alpha should be in [0,1]!')
  }
  
  # checking that list.est contains the required elements
  if (is.null(list.est$x.hat) == TRUE | is.null(list.est$x.hat.se) == TRUE) {
    stop('Error: list.est does not have the component(s) x.hat and/or x.hat.se')
  }
  if (is.null(list.est$p.hat) == TRUE | is.null(list.est$p.hat.se) == TRUE) {
    stop('Error: list.est does not have the component(s) p.hat and/or p.hat.se')
  }
  
  # checking if the lenghts of the required inputs are consistent
  if (length(list.est$x.hat) != length(list.est$x.hat.se)) {
    stop('Error: lengths of x.hat and x.hat.se components are not equal!')
  }  
  if (length(list.est$p.hat) != length(list.est$p.hat.se)) {
    stop('Error: lengths of p.hat and p.hat.se components are not equal!')
  }
  
  # computing the confidence interval
  l <- qnorm(1 - alpha * 0.5)  
  
  # ... lower bound (counts)
  ci.lo <- Array2Vector(list.est$x.hat) - l * list.est$x.hat.se
  ci.lo <- Vector2Array(ci.lo, dim(list.est$x.hat))
  dimnames(ci.lo) <- dimnames(list.est$x.hat)
  # ... upper bound (counts)
  ci.up <-Array2Vector(list.est$x.hat) + l * list.est$x.hat.se
  ci.up <- Vector2Array(ci.up, dim(list.est$x.hat))
  dimnames(ci.up) <- dimnames(list.est$x.hat)
  # ... lower bound (probabilities)  
  ci.lo.p <-Array2Vector(list.est$p.hat) - l * list.est$p.hat.se
  ci.lo.p <- Vector2Array(ci.lo.p, dim(list.est$x.hat))
  dimnames(ci.lo.p) <- dimnames(list.est$x.hat)
  # ... upper bound (probabilities)
  ci.up.p <-Array2Vector(list.est$p.hat) + l * list.est$p.hat.se
  ci.up.p <- Vector2Array(ci.up.p, dim(list.est$x.hat))
  dimnames(ci.up.p) <- dimnames(list.est$x.hat)
  
  # returning the result
  result <- list("lower.x" = ci.lo, "upper.x" = ci.up,
                 "lower.p" = ci.lo.p, "upper.p" = ci.up.p)
  return(result)
  
}

# File mipfp/R/ipfpMultiDim.R
# by Johan Barthelemy and Thomas Suesse
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 or 3 of the License
#  (at your option).
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/

# ------------------------------------------------------------------------------
# This file provides the functions Ipfp and Ipfp.Covar that respectively
# implements the iterative proportional fitting procedure and a Delta method
# that computes the covariance matrix of the estimate produced by Ipfp.
# ------------------------------------------------------------------------------

Ipfp <- function(seed, target.list, target.data, print = FALSE, iter = 1000, 
                 tol = 1e-10, tol.margins = 1e-10, na.target = FALSE) {
  # Update an array using the iterative proportional fitting procedure.
  #
  # Author: J. Barthelemy
  #  
  # Args:
  #   seed: The initial multi-dimensional array to be updated. Each cell must
  #         be non-negative.
  #   target.list: A list of the target margins provided in target.data. Each
  #                component of the list is an array whose cells indicates
  #                which dimension the corresponding margin relates to.
  #   target.data: A list containing the data of the target margins. Each
  #                component of the list is an array storing a margin.
  #                The list order must follow the one defined in target.list. 
  #                Note that the cells of the arrays must be non-negative, but
  #                can contains NA values.
  #   print: Verbose parameter: if TRUE prints the current iteration number
  #          and the value of the stopping criterion.
  #   iter: The maximum number of iteration allowed; must be greater than 0.
  #   tol: If the maximum absolute difference between two iteration is lower
  #        than the value specified by tol, then ipfp has reached convergence
  #        (stopping criterion); must be greater than 0.
  #   tol.margins: The tolerance for margins consistency.
  #   na.target: If set to TRUE, allows the targets to have NA cells. In that
  #              case the margins consistency is not checked.
  #
  # Returns: A mipfp object consisting of a list whose elements are
  #   call: A call object in which all the specified arguments are given by
  #         their full names.
  #   method: The selected method for estimation.
  #   stp.crit: The final value of the stopping criterion.
  #   evol.stp.crit: Evolution of the stopping criterion over the iterations.
  #   conv: A boolean indicating whether the algorithm converged to a solution.
  #   error.margins: A list returning, for each margin, the absolute maximum 
  #                  deviation between the target and generated margin.
  
  # checking if a seed is provided
  if (is.null(seed) == TRUE) {
    stop('Error: no seed specified!')
  }
  
  # checking if target are provided
  if (is.null(target.data) == TRUE | is.null(target.data) == TRUE) {
    stop('Error: target.data and/or target.data not specified!')
  }
  
  # checking if NA in target cells if na.target is set to FALSE
  if (is.na(min(sapply(target.data, min))) == TRUE & na.target == FALSE)  {
    stop('Error: NA values present in the margins - use na.target = TRUE!')
  }
  
  # checking if NA in seed
  if (is.na(min(seed)) == TRUE) {
    stop('Error: NA values present in the seed!')
  }
  
  # checking non negativity condition for the seed and the target
  if (min(sapply(target.data, min), na.rm = na.target) < 0 | min(seed) < 0) {
    stop('Error: Target and Seed cells must be non-negative!')    
  }  
  
  # checking the strict positiviy of tol and iter
  if (iter < 1 | tol <= 0.0) {
    stop('Error: tol and iter must be strictly positive!')
  }
  
  # checking if NA allowed and requesting the covariance matrices
  if (na.target == TRUE) { #& compute.cov == TRUE) {
    warning('Missing values allowed in the target margins.
             Computation of the covariance matrices set to FALSE!')
    compute.cov <- FALSE
  }
  
  # checking the margins consistency if no missing values in the targets
  error.margins <- TRUE  
  if (na.target == FALSE) {
    if (length(target.data) > 1) {
      for (m in 2:length(target.data)) {      
        if (abs(sum(target.data[[m-1]]) - sum(target.data[[m]])) > 
            tol.margins) {
          error.margins <- FALSE
          warning('Target not consistents - shifting to probabilities!
                  Check input data!\n')
          break
        }      
      }
    }
  } else {
    if (print == TRUE) {
      cat('NOTE: Missing values present in target cells. ')
      cat('Margins consistency not checked!\n')  
    }        
  }
  
  # if margins are not consistent, shifting from frequencies to probabilities
  if (error.margins == FALSE) {
    seed <- seed / sum(seed)
    for (m in 1:length(target.data)) {
      target.data[[m]] <- target.data[[m]] / sum(target.data[[m]])
    }
  }
  
  if (print == TRUE & error.margins == TRUE & na.target == FALSE) {
    cat('Margins consistency checked!\n')
  }
    
  # initial value is the seed
  result <- seed  
  converged <- FALSE
  tmp.evol.stp.crit <- vector(mode="numeric", length = iter)
  
  # ipfp iterations
  for (i in 1:iter) {
    
    if (print == TRUE) {
      cat('... ITER', i, '\n')
    } 
    
    # saving previous iteration result (for testing convergence)
    result.temp <- result
            
    # loop over the constraints
    for (j in 1:length(target.list)) {
      # ... extracting current margins      
      temp.sum <- apply(result, target.list[[j]], sum)
      # ... computation of the update factor, taking care of 0 and NA cells   
      update.factor <- ifelse(target.data[[j]] == 0 | temp.sum == 0, 0,
                              target.data[[j]] / temp.sum)
      if (na.target == TRUE) {
        update.factor[is.na(update.factor)] <- 1;
      }
      # ... apply the update factor
      result <- sweep(result, target.list[[j]], update.factor, FUN = "*")
    }
    
    # stopping criterion
    stp.crit <- max(abs(result - result.temp))
    tmp.evol.stp.crit[i] <- stp.crit
    if (stp.crit < tol) {
      converged <- TRUE
      if (print == TRUE) {
        cat('       stoping criterion:', stp.crit, '\n')
        cat('Convergence reached after', i, 'iterations!\n')
      } 
      break
    }
    
    if (print == TRUE) {
      cat('       stoping criterion:', stp.crit, '\n')
    }
    
  }
    
  # checking the convergence
  if (converged == FALSE) {
    warning('IPFP did not converged after ', iter, ' iteration(s)! 
            This migh be due to 0 cells in the seed, maximum number 
            of iteration too low or tolerance too small\n')
  }        
  
  # computing final max difference between generated and target margins
  diff.margins <- vector(mode = "numeric", length = length(target.list))
  if (na.target == FALSE) {
    for (j in 1:length(target.list)) {
      diff.margins[j] = max(abs(target.data[[j]] 
                                - apply(result, target.list[[j]], sum)))
      if (is.null(names(dimnames(seed))) == FALSE) {
        names(diff.margins)[j] <- paste(names(dimnames(seed))[target.list[[j]]],
                                        collapse = ".")
      }
    }
  }
  
  # storing the evolution of the stopping criterion
  evol.stp.crit <- tmp.evol.stp.crit[1:i]
  
  # computing the proportions
  result.prop <- result / sum(result)
  
  # gathering the results in a list
  results.list <- list("x.hat" = result, "p.hat" = result.prop, 
                       "conv" = converged, "error.margins" = diff.margins, 
                       "evol.stp.crit" = evol.stp.crit)
  
  # adding the method applied
  results.list$method <- "ipfp"
  
  # adding the calling expression
  results.list$call <- match.call()
  
  # updating the class attribute
  class(results.list) <- c("list", "mipfp")      
  
  # returning the result
  return(results.list)
  
}

# File mipfp/R/binary.R
# by Johan Barthelemy and Thomas Suesse
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 or 3 of the License
#  (at your option).
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/

# ------------------------------------------------------------------------------
# This files provides the following functions focusing on multivariate Bernoulli
# (binary) variables:
#   * Odds2PairProbs: Converts odds ratio between K binary variables to pairwise
#                     probability.
#   * Corr2PairProbs: Converts correlation between K binary variables to 
#                     pairwise probability.
#   * Odds2Corr: Converts odds ratios between K binary variables to correlation.
#   * Corr2Odds: Converts correlation between K binary variables to odds ratios.
#   * ObtainMultBinaryDist: Determines a multivariate binary joint-distribution.
#   * RMultBinary: Simulate multivariate binary data using Ipfp.
# ------------------------------------------------------------------------------

Odds2PairProbs <- function(odds, marg.probs) {
  # Converts odds ratio between K Bernoulli variables to pairwise probability.
  # 
  # This function transforms the odds ratio measure of association O_ij between
  # K binary (Bernoulli) random variables X_i and X_j to the pairwise 
  # probability P(X_i = 1, X_j = 1) where O_ij is defined as
  # O_ij = P(X_i = 1, X_j = 1) * P(X_i = 0, X_j = 0) 
  #        / P(X_i = 1, X_j = 0) * P(X_i = 0, X_j = 1).
  #  
  # Author: T. Suesse
  #  
  # Args:
  #   odds: A K x K matrix where the i-th row and the j-th colum represents the
  #         odds ratio O_ij.
  #   marg.probs: A vector with K elements of marginal probabilities with the
  #               i-th entry refering to P(X_i = 1).
  #
  # Returns: A matrix of the same dimension as odds containing the pairwise
  #          probabilities.
  
  # checking if input argument odds is valid
  if (is.null(odds) == TRUE | min(odds) < 0.0) {
    stop('Error: odds ratio odds misspecified!')
  }
  
  # checking if input argument marg.probs is specified
  if (is.null(marg.probs) == TRUE | min(marg.probs < 0.0)) {
    stop('Error: marg.probs missspecified!')
  }
  
  # determining some initial variables  
  K <- length(marg.probs)
  pair.proba <- matrix(0.0, K, K)
  
  # construction the upper triangular part of the final matrix
  # ... loop over the rows
  for (i in 1:(K - 1)) {
    
    # ... loop over the columns
    for (j in (i + 1):K) {
      
      # find pairwise probabilities by solving a quadratic polynomial      
      coeff <- c(odds[i, j] * marg.probs[i] * marg.probs[j], 
                 - (1 + (odds[i, j] - 1) * (marg.probs[i] + marg.probs[j])),                 
                 odds[i,j] - 1)
      roots <- Re(polyroot(coeff))
      
      # determining the solution wrt to the constraints sets by marg.probs
      s1 <- min(marg.probs[i], marg.probs[j])
      s2 <- max(0.0, marg.probs[i] + marg.probs[j] - 1.0)      
      cond <- (roots <= s1 & roots >= s2)      
      
      # ... no suitable solution
      if (max(cond) == FALSE) {
        stop("ERROR for variable ", i, " and variable ", j,
             ": Pairwise probability exceed limits given by marg.probs!\n")
      }
      
      # ... first suitable solution
      if (cond[1] == TRUE) {
        pair.proba[i, j] <- roots[1]
      } else {
        pair.proba[i, j] <- roots[2]
      }
      
    }
    
  }
  
  # adding the lower triangular part of the final matrix
  pair.proba <- pair.proba + t(pair.proba)
  
  # adding the diagonal of the final matrix
  diag(pair.proba) <- marg.probs
  
  # adding the dimension names
  dimnames(pair.proba) <- dimnames(odds)
  
  # returning the result
  return(pair.proba)
  
}

Corr2PairProbs <- function(corr, marg.probs) {
  # Converts correlation between K Bernoulli variables to pairwise probability.
  # 
  # This function transforms the correlation measure of association C_ij between
  # K binary (Bernoulli) random variables X_i and X_j to the pairwise
  # probability P(X_i = 1, X_j = 1) where C_ij is defined as
  # C_ij = cov(X_i, X_j) / sqrt(var(X_i) * var(X_j)).
  #  
  # Author: T. Suesse
  #  
  # Args:
  #   corr: A K x K matrix where the i-th row and the j-th colum represents the
  #         correlation C_ij.
  #   marg.probs: A vector with K elements of marginal probabilities with the
  #               i-th entry refering to P(X_i = 1).
  #
  # Returns: A matrix of the same dimension as corr containing the pairwise
  #          probabilities.
  
  # checking if input argument corr is specified
  if (is.null(corr) == TRUE ) {
    stop('Error: correlations corr not specified!')
  }
  
  # checking if input argument marg.probs is specified
  if (is.null(marg.probs) == TRUE | min(marg.probs < 0.0)) {
    stop('Error: marg.probs missspecified!')
  }
  
  K <- length(marg.probs)
  
  # determing the pairwise probabilities
  pair.proba <- corr * sqrt((marg.probs * (1 - marg.probs)) %*% 
                              t((marg.probs * (1 - marg.probs)))) + 
    marg.probs %*% t(marg.probs)
  
  # determining the constrains
  p.col <- matrix(marg.probs, K, K, byrow = TRUE)
  p.row <- t(p.col)
  s1 <- pmin(p.col, p.row)
  s2 <- pmax(matrix(0, K, K), p.col + p.row - 1)
  
  # assessing constraints
  cond <- matrix(as.logical((pair.proba <= s1) & (pair.proba >= s2)), K, K)
  diag(cond) <- TRUE
  
  if (min(cond) == FALSE) {
    warning("Correlation exceeds constrains set by marg.probs, i.e. ",
            "pair.proba[i, j] <= marg.probs[i]\n")
    cat("Problematic pairs:\n")
    print(which(cond == min(cond), arr.ind = TRUE))
  }
  
  # adding the dimension names
  dimnames(pair.proba) <- dimnames(corr)
  
  # returning the pairwise probabilities matrix
  return(pair.proba)
  
}

Odds2Corr <- function(odds, marg.probs) {
  # Converts odds ratios between K Bernoulli variables to correlation.
  # 
  # Assuming that there is K binary (Bernoulli) random variables X_1, ..., X_K, 
  # this function transforms the odds ratios measure of association O_ij of  
  # every pair (X_i, X_j) to the correlation C_ij where C_ij is defined as 
  # C_ij = cov(X_i, X_j) / sqrt(var(X_i) * var(X_j)) and
  # O_ij = P(X_i = 1, X_j = 1) * P(X_i = 0, X_j = 0) /
  #            P(X_i = 1, X_j = 0) * P(X_i = 0, X_j = 1).
  #  
  # Author: T. Suesse
  #  
  # Args:
  #   odds: A K x K matrix where the i-th row and the j-th colum represents the
  #         odds ratio O_ij.
  #   marg.probs: A vector with K elements of marginal probabilities with the
  #               i-th entry refering to P(X_i = 1).
  #
  # Returns: A list whose elements are
  #   corr: A matrix of the same dimension as odds containing the correlation
  #   pair.proba: A matrix of the same dimension as odds containing the pairwise
  #               probabilities.
  
  # checking if input argument odds is valid
  if (is.null(odds) == TRUE | min(odds) < 0.0) {
    stop('Error: odds ratio odds misspecified!')
  }
  
  # checking if input argument marg.probs is specified
  if (is.null(marg.probs) == TRUE | min(marg.probs < 0.0)) {
    stop('Error: marg.probs missspecified!')
  }
  
  # computing the pairwise probabilities and correlation matrix
  pair.proba <- Odds2PairProbs(odds, marg.probs)
  corr <- (pair.proba - marg.probs %*% t(marg.probs)) / 
    sqrt((marg.probs * (1 - marg.probs)) %*% 
           t((marg.probs * (1 - marg.probs))))  
  
  # adding the dimension names
  dimnames(corr) <- dimnames(odds)
  
  # returning the correlation and pairwise probabilities matrices
  return(list("corr" = corr, "pair.proba" = pair.proba)) 
  
}

Corr2Odds <- function(corr, marg.probs) {
  # Converts correlation between K Bernoulli variables to odds ratio.
  # 
  # This function transforms the correlation measure of association C_ij between
  # K binary (Bernoulli) random variables X_i and X_j to the odds ratios O_ij
  # where C_ij is defined as C_ij = cov(X_i, X_j) / sqrt(var(X_i) * var(X_j))
  # and O_ij = P(X_i = 1, Y_j = 1) * P(X_i = 0, Y_j = 0) /
  #            P(X_i = 1, Y_j = 0) * P(X_i = 0, Y_j = 1).
  #  
  # Author: T. Suesse
  #  
  # Args:
  #   corr: a K x K matrix where the i-th row and the j-th colum represents the
  #         correlation C_ij.
  #   marg.probs: a vector with K elements of marginal probabilities with the
  #               i-th entry refering to P(X_i = 1).
  #
  # Returns: A list whose elements are
  #   corr: A matrix of the same dimension as odds containing the correlation.
  #   pair.proba: A matrix of the same dimension as odds containing the pairwise
  #               probabilities.
  
  # checking if input argument corr is specified
  if (is.null(corr) == TRUE ) {
    stop('Error: correlations corr not specified!')
  }
  
  # checking if input argument marg.probs is specified
  if (is.null(marg.probs) == TRUE | min(marg.probs < 0.0)) {
    stop('Error: marg.probs missspecified!')
  }
  
  K <- length(marg.probs)
  
  # computing the pairwise probabilitie
  pair.proba <- Corr2PairProbs(corr, marg.probs)
  
  # computing the odds ratios
  mu.x <- matrix(marg.probs, K, K, byrow = TRUE)
  mu.y <- matrix(marg.probs, K, K, byrow = FALSE)
  odds <- pair.proba * (1 - mu.x - mu.y + pair.proba) / 
    ((mu.x - pair.proba) * (mu.y - pair.proba))
  diag(odds) <- Inf
  
  # adding the dimension names
  dimnames(odds) <- dimnames(corr)
  
  # returning the matrices of correlation and pairwise probabilities
  return(list("odds" = odds, "pair.proba" = pair.proba))
  
}

ObtainMultBinaryDist <- function(odds = NULL, corr = NULL, marg.probs, ...) {
  # Generates a multivariate binary joint-distribution.
  # 
  # Applies the IPFP procedure to obtain a joint distribution of K multivariate 
  # binary variables. It requires as input the odds ratio or alternatively the 
  # correlation as a measure of association between all the binary variables and
  # a vector of marginal probabilities. This function is useful when one wants 
  # to simulate from a multivariate binary distribution when only first order
  # (marginal probabilities) and second order moments (correlation OR 
  # odds ratio) are available.
  #
  # Author: T. Suesse
  #  
  # Args:
  #   odds: A K x K matrix where the i-th row and the j-th colum represents the
  #         odds ratio O_ij.
  #   corr: A K x K matrix where the i-th row and the j-th colum represents the
  #         correlation C_ij.
  #   marg.probs: A vector with K elements of marginal probabilities with the
  #               the i-th entry refering to P(X_i = 1).
  #   ...: arguments that can be passed to the Ipfp function such as tol, iter,
  #        print, compute.cov.
  #     
  # Returns: A list generated by the Ipfp function whose elements are
  #   joint.proba: Resulting multivariate joint-probabilities.
  #   stp.crit: Final value of the stopping criterion.
  #   evol.stp.crit: Evolution of the stopping criterion over the iterations.
  #   conv: boolean Indicating whether the algorithm converged to a solution.
  #   check.margins: A list returning, for each margin, the absolute maximum 
  #                  deviation between the desired and generated margin.
  #   label: The names of the variables.
  
  # checking if marginal probabilities are provided
  if (is.null(marg.probs) == TRUE) {
    stop("Marginal probabilities need to be provided!\n")
  }
  
  # checking if odds ratio or correlations are provided
  if (is.null(odds) == TRUE & is.null(corr) == TRUE) {
    stop("Correlation or odds ratios must be provided in a K by K matrix!")
  }
  
  # generation of the pairwise probabilities
  if (is.null(odds) == TRUE) {
    pair.proba <- Corr2PairProbs(corr, marg.probs)    
  } else {  
    pair.proba <- Odds2PairProbs(odds, marg.probs)    
  }
  
  # retrieving and storing the label of the variables
  lab = rownames(pair.proba)
  
  # generating the Ipfp seed
  K <- length(marg.probs)
  K2 <- 2^K
  seed <- array(rep(1, K2), dim = rep(2, K))
  
  # initialize the Ipfp constraints
  target.data <- list()
  target.list <- list()
  
  # fixing the marginal probabilities (Ipfp constraints)
  for (k in 1:K) {
    target.data[[k]] <- c(marg.probs[k], 1 - marg.probs[k])
    target.list[[k]] <- k
  }
  
  # fixing the pairwise probabilities (Ipfp constraints)
  index <- K  
  # ... loop over the rows
  for (i in 1:(K - 1)) {      
    # ... loop over the columns
    for (j in (i + 1):K) {      
      index <- index + 1
      target.data[[index]] <- array(c(pair.proba[i, j], NA, NA, NA), 
                                    dim = c(2, 2))
      target.list[[index]] <- c(i, j)      
    }    
  }
  
  # obtain the joint-probabilities
  joint.proba <- Ipfp(seed = seed, target.list = target.list, 
                      target.data = target.data, na.target = TRUE, ...)
  
  # gathering the results
  results <- list("joint.proba" = joint.proba$p.hat, 
                  "stp.crit" = joint.proba$stp.crit, "conv" = joint.proba$conv,
                  "check.margins" = joint.proba$check.margins,
                  "label" = lab)
  
  # returning the generated joint-distribution
  return(results)
  
}

RMultBinary <- function(n = 1, mult.bin.dist, target.values = NULL) {
  # Simulate multivariate Bernoulli distribution.
  # 
  # This function generates a sample from a multinomial distribution of K 
  # dependent binary (Bernoulli) variables (X_1, X_2, ..., X_K) defined by an
  # array (of 2^K cells) of joint-probabilities.
  #
  # Author: T. Suesse
  #  
  # Args:
  #   n: Desired sample size. Default = 1.
  #   mult.bin.dist: A list detailing the multivariate distribution containing
  #                  - joint.proba:
  #                    an array detailing the joint-probabilities of the K 
  #                    binary variables. The array has K dimensions of size 2, 
  #                    referring to the 2 possible outcome of the considered
  #                    variable). Hence, the total number of elements is 2^K;
  #                  - var.labels (optionnal)
  #                    the names of the K variables.
  #                  This list can be generated via the ObtainMultBinaryDist
  #                  function.
  #   target.values: A list describing the possibles outcomes of each binary
  #                  variable. By default = {0, 1}.
  #     
  # Returns: A list whose elements are
  #   binary.sequences: The generated K x n random sequence.
  #   possible.binary.sequences: The possible binary sequences, i.e. the domain.
  #   chosen.random.index: The index of the random draws in the domain.
  
  if (is.null(mult.bin.dist) == TRUE) {
    stop("A list detailing the multivariate binary distribution to be simulated
         must be provide! The list must contain at least an array detailing the
         joint-probabilities (see ObtainMultBinaryDist)\n")
  }
  
  if (is.null(mult.bin.dist$joint.proba) == TRUE) {
    stop("the mult.bin.dist list must at least contain an element joint.proba
         (an array detailing the joint-probabilities). See 
         ObtainMultBinaryDist to generate an appropriate structure.")   
  }
  
  # retrieving the variables names
  if (is.null(mult.bin.dist$label) == FALSE) {
    var.labels = mult.bin.dist$label    
  } else {
    var.labels <- NULL
  }
  
  array.prob = mult.bin.dist$joint.proba
  dims <- dim(array.prob)
  K <- length(dims)
  
  # initialization of the possible outcome for each attribute
  if (is.null(target.values) == TRUE) {
    target.values <- vector("list", K)    
    target.values[] <- list(c(1,0))
  }
  
  # gives matrix of size 2^K times n 
  y <- rmultinom(n = n, size = 1, prob = c(array.prob))
  
  # gives observations 1:2^K
  y <- apply(y, 2, which.max)
  
  # transform this number to binary sequence
  domain <- expand.grid(target.values)
  binary.sequences <- as.matrix(domain[y, ])
  rownames(binary.sequences) <- NULL  
  colnames(binary.sequences) <- var.labels
  
  # returning the n random sequences of size K
  return(list("binary.sequences" = binary.sequences, "chosen.random.index" = y, 
              "possible.binary.sequences" = domain))
  
}

\name{IpfpCov}
\alias{IpfpCov}
\title{
Covariance matrix of the estimators produced by Ipfp (deprecated)
}
\description{
This function determines the (asymptotic) covariance matrix of the estimates 
produced by the iterative proportional fitting procedure using the formula 
designed by Little and Wu (1991).
}
\usage{
IpfpCov(estimate, seed, target.list, replace.zeros = 1e-10)
}
\arguments{
  \item{estimate}{
    The array of estimates produced by the \code{\link[mipfp:Ipfp]{Ipfp}}
    function.
}
  \item{seed}{
    The intial array (seed) that was updated by the 
    \code{\link[mipfp:Ipfp]{Ipfp}} function.
}
  \item{target.list}{
    A list of dimensions of the marginal target constrains. Each component of 
    the list is an array whose cells indicate which dimension the corresponding 
    margin relates to.
}
  \item{replace.zeros}{
    If a cell of the \code{estimate} or the \code{seed} has a value equals to 
    0, then it is replaced with this value. Default is 1e-10.
}
}
\details{
The asymptotic covariance matrix of the estimates produced by the iterative
proportional fitting procedure has the form (Little and Wu, 1991)
\deqn{K(K^T D1^{-1} K)^{-1} K^T D2^{-1} K (K^T D1^{-1} K)^{-1} K^T}{
      K * inv(t(K) * inv(D1) * K) * t(K) * inv(D2) * K * inv(t(K) * inv(D1)
      * K) * t(K)}
where
\itemize{
  \item{\code{K} is the orthogonal complement of the marginal matrix, i.e. the 
    matrix required to obtain the marginal frequencies;}
  \item{\code{D1} is a diagonal matrix of the estimates probabilities;}
  \item{\code{D2} is a diagonal matrix of the seed probabilities.}
}
}
\value{
A matrix of dimension \code{length(estimate) x length(estimate)} of the
asymptotic variance of the proportion estimates produced by \code{Ipfp}.  
}
\references{
 Little, R. J., Wu, M. M. (1991)
 Models for contingency tables with known margins when target and seed 
 populations differ.
 \emph{Journal of the American Statistical Association} 86 (413): 87-95.
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\section{Warning}{
Note: this function is deprecated, instead use
\code{\link[mipfp:vcov.mipfp]{vcov.mipfp}}.
}
\seealso{
\code{\link[mipfp:Ipfp]{Ipfp}} function to update an initial multidimensional
array with respect to given constraints.
}
\examples{
# true contingency (2-way) table
true.table <- array(c(43, 44, 9, 4), dim = c(2, 2))
# generation of sample, i.e. the seed to be updated
seed <- ceiling(true.table / 10)
# desired targets (margins)
target.row <- apply(true.table, 2, sum)
target.col <- apply(true.table, 1, sum)
# storing the margins in a list
target.data <- list(target.col, target.row)
# list of dimensions of each marginal constrain
target.list <- list(1, 2)
# calling the Ipfp function
res <- Ipfp(seed, target.list, target.data)
# computation of the covariance matrix of the produced estimated probabilities
res.cov <- IpfpCov(res$x.hat, seed, target.list)
# 0.95 level confidence interval of the estimates
n <- sum(res$x.hat)
# ... lower bound
ci.lb <- Array2Vector(res$x.hat) - 1.96 * sqrt(n * diag(res.cov))
# ... upperbound
ci.ub <- Array2Vector(res$x.hat) + 1.96 * sqrt(n * diag(res.cov))
}
\concept{multiway contingency table estimation}
\concept{multivariate contingency table estimation}
\keyword{models}
\keyword{multivariate}
\keyword{array}

\name{RMultBinary}
\alias{RMultBinary}
\alias{Bernoulli}
\alias{RMultBernoulli}
\title{Simulating a multivariate Bernoulli distribution
}
\description{
This function generates a sample from a multinomial distribution of \eqn{K}
dependent binary (Bernoulli) variables
\eqn{(X_1, X_2, ..., X_K)}{(X_1, X_2, ..., X_K)} defined by an array 
(of 2^K cells) detailing the joint-probabilities.
}
\usage{
RMultBinary(n = 1, mult.bin.dist, target.values = NULL)
}
\arguments{
  \item{n}{
    Desired sample size. Default = 1.
}
  \item{mult.bin.dist}{
    A list describing the multivariate binary distribution. It can be generated
    by the \code{\link[mipfp]{ObtainMultBinaryDist}} function.
    The list contains at least the element \code{joint.proba}, an array 
    detailing the joint-probabilities of the \eqn{K} 
    binary variables. The array has \eqn{K} dimensions of size 2, referring to 
    the 2 possible outcomes of the considered variable. Hence, the total number 
    of elements is \eqn{2^K}{2^K}.
    Additionnaly the list can also provides the element \code{var.label}, a list
    containing the names of the \eqn{K} variables.    
}
  \item{target.values}{
    A list describing the possibles outcomes of each binary variable, for 
    instance \{1, 2\}. Default = \{0, 1\}.
}
}
\value{
A list whose elements are detailed herehunder.
  \item{binary.sequences}{
  The generated \eqn{K \times n}{K x n} random sequence.
}
  \item{possible.binary.sequences}{
    The possible binary sequences, i.e. the domain.
}
  \item{chosen.random.index}{
    The index of the random draws in the domain.
}
}
\references{
  Lee, A.J. (1993).
  Generating Random Binary Deviates Having Fixed Marginal Distributions and 
  Specified Degrees of Association.
  \emph{The American Statistician}  47 (3): 209-215.
 
  Qaqish, B. F., Zink, R. C., and Preisser, J. S. (2012).
  Orthogonalized residuals for estimation of marginally specified association
  parameters in multivariate binary data.
  \emph{Scandinavian Journal of Statistics} 39, 515-527.
}
\author{
Thomas Suesse 

Maintainer: Johan Barthelemy <johan@uow.edu.au>.
}
\seealso{
\code{\link[mipfp]{ObtainMultBinaryDist}} for estimating the 
joint-distribution required by this function.
}
\examples{
# from Qaqish et al. (2012)
or <- matrix(c(Inf, 0.281, 2.214, 2.214,
               0.281, Inf, 2.214, 2.214,
               2.214, 2.214, Inf, 2.185,
               2.214, 2.214, 2.185, Inf), nrow = 4, ncol = 4, byrow = TRUE)
rownames(or) <- colnames(or) <- c("Parent1", "Parent2", "Sibling1", "Sibling2")

# hypothetical marginal probabilities
p <- c(0.2, 0.4, 0.6, 0.8)

# estimating the joint-distribution
p.joint <- ObtainMultBinaryDist(odds = or, marg.probs = p)

# simulating 100,000 draws from the obtained joint-distribution
y.sim <- RMultBinary(n = 1e5, mult.bin.dist = p.joint)$binary.sequences

# checking results
cat('dim y.sim =', dim(y.sim)[1], 'x', dim(y.sim)[2], '\n')
cat('Estimated marginal probs from simulated data\n')
apply(y.sim,2,mean)
cat('True probabilities\n')
print(p)
cat('Estimated correlation from simulated data\n')
cor(y.sim)
cat('True correlation\n')
Odds2Corr(or,p)$corr

# generating binary outcomes with outcome different than 0, 1
RMultBinary(n = 10, mult.bin.dist = p.joint, 
            target.values = list(c("A", "B"), c(0, 1), c(1, 2), c(100, 101)))
}
\concept{Bernoulli}
\concept{random draws}
\keyword{multivariate}
\keyword{distribution}
\keyword{datagen}

\name{confint.mipfp}
\alias{confint.mipfp}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Computing confidence intervals for the mipfp estimates
}
\description{
This function computes the (asymptotic) Wald confidence intervals at a given 
significance level for the estimates of an \code{mipfp} object generated by
\code{\link[mipfp:Estimate]{Estimate}}.
}
\usage{
\method{confint}{mipfp}(object, parm, level = 0.95, prop = FALSE, ...)
}
\arguments{
  \item{object}{
    The \code{mipfp} object containing the estimates.
}
  \item{parm}{
    A specification of which estimates are to be given confidence intervals, 
    either a vector of numbers or a vector of names. If missing, all estimates
    are considered.
}
  \item{level}{
    The confidence level required.
}
  \item{prop}{
    A boolean indicating if the results should be using counts (\code{FALSE}) or
    proportion (\code{TRUE}). Default is \code{FALSE}.
}
  \item{\dots}{
    Further arguments passed to or from other methods (for instance
    \code{\link[mipfp:vcov.mipfp]{vcov.mipfp}}).
}
}
\details{
The confidence interval of the estimates \eqn{\hat{X}}{X.hat}, at significance
level \eqn{\alpha}{\alpha} is given by
\deqn{\hat{X} \pm z \left( 1-\frac{\alpha}{2} \right) * 
\hat{\sigma}}{X.hat +/- z(1-\alpha/2) * \sigma.hat}
where \eqn{\hat{\sigma}}{\sigma.hat} is the standart deviations of 
\eqn{\hat{X}}{X.hat}, \eqn{z}{z} and 
\eqn{\alpha = 1 - level}{\alpha = 1 - level} is the inverse of the cumulative 
distribution function of the standard normal distribution.
}
\value{
  A matrix containing the upper and lower bounds for the estimated
  counts/probabilities (depending on the value of the \code{prop} argument).
}
\references{
 Smithson, M. (2002).
 \emph{Confidence intervals}.
 Sage Publications.
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
\code{\link[stats:confint.default]{confint}} for the default method to compute 
confidence intervals for model parameters.
\code{\link[mipfp:Estimate]{Estimate}}, \code{\link[mipfp:Ipfp]{Ipfp}} and 
\code{\link[mipfp:ObtainModelEstimates]{ObtainModelEstimates}} to generate the
\code{mipfp} objects for this function.
}
\examples{
# true contingency (2-way) table
true.table <- array(c(43, 44, 9, 4), dim = c(2, 2))
# generation of sample, i.e. the seed to be updated
seed <- ceiling(true.table / 10)
# desired targets (margins)
target.row <- apply(true.table, 2, sum)
target.col <- apply(true.table, 1, sum)
# storing the margins in a list
target.data <- list(target.col, target.row)
# list of dimensions of each marginal constrain
target.list <- list(1, 2)
# using ipfp
res <- Estimate(seed, target.list, target.data)
# computing and printing the confidence intervals
print(confint(res))
}
\concept{confidence interval}
\keyword{multivariate}

\name{Qaqish}
\alias{Qaqish}
\docType{data}
\title{
Qaqish
}
\description{
The data set provides the odds ratios and correlations as measures of 
associations of the binary outcome impaired pulmonary function for a family of 
four with two parents and two siblings.

These correlations and odds ratios are obtained from Qaqish et al. (2012) based
on a regression analysis of a common data set of parents and siblings with 
chronic obstructive pulmonary disease and their controls.
}
\usage{data(Qaqish)}
\format{
A list \code{Qaqish} containing 2 elements:
\enumerate{
  \item \code{cr} : the correlation matrix;
  \item \code{or} : the odd ratios matrix.
}
}
\source{
  Qaqish, B. F., Zink, R. C., and Preisser, J. S. (2012).
  Orthogonalized residuals for estimation of marginally specified association
  parameters in multivariate binary data.
  \emph{Scandinavian Journal of Statistics} 39, 515-527.
}
\examples{
data(Qaqish)
print(Qaqish$or)
print(Qaqish$cr)
}
\keyword{datasets}

\name{expand}
\alias{expand}
\alias{expand.default}
\alias{expand.table}

\title{
Expand a Table in a Data Frame
}
\description{
This function takes a multi-dimensionnal contingency table and expands it to a 
data frame containing individual records.
}
\usage{
expand(x, ...)

\method{expand}{table}(x, ...)
}
\arguments{
  \item{x}{
    An object of type \code{table} storing a N-dimensial contingency table.
}
  \item{\dots}{
    Further arguments passed to or from other methods.
}
}
\value{
A data frame of the individual records derived from \code{x}.
}
\references{
  Cookbook for R - 
  \url{http://www.cookbook-r.com/Manipulating_data/Converting_between_data_frames_and_contingency_tables/}
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\note{
The function is inspired from the "Cookbook for R".

It should also be noted that the cells od \code{x} are rounded before being
expanded in a data frame.
}
\seealso{
\code{\link[base]{expand.grid}} and \code{\link[base]{as.data.frame}}.
}
\examples{
# loading data
data(spnamur, package = "mipfp")
# subsetting the data frame, keeping only the first 3 variables
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
# create a contingency table
t <- table(spnamur.sub)
# expand the table to a data frame
t.df <- expand(t)
}
\keyword{manip}
\keyword{datagen}
\keyword{multivariate}

\name{error.margins}
\alias{error.margins}
\alias{error.margins.default}
\alias{error.margins.mipfp}
\title{
Extracts the deviation between every target and generated margin
}
\description{
This method returns the maximum deviation between each generated and 
desired margins of the input argument. It corresponds to the absolute
maximum deviation between each target margin used to generate the estimates
in the mipfp object and the generated one.
}
\usage{
\method{error.margins}{mipfp}(object, ...)
}
\arguments{
  \item{object}{
    An object of class \code{mipfp}.
}
  \item{\dots}{
    Further arguments passed to or from other methods. See 
    \code{\link[mipfp:CompareMaxDev]{CompareMaxDev}}.
}
}
\value{
An array containing the absolute maximum deviations for each margin.
}
\author{
Johan Barthelemy

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\note{
It is an alias for \code{\link[mipfp:CompareMaxDev]{CompareMaxDev}} when
only one object is passed to the function and the verbose parameter is set to
\code{FALSE}.
}
\seealso{
The estimation function \code{\link[mipfp:Estimate]{Estimate}}.

This function relies on 
\code{\link[mipfp:CompareMaxDev]{CompareMaxDev}}.
}
\examples{
# loading the data
data(spnamur, package = "mipfp")
# subsetting the data frame, keeping only the first 3 variables
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
# true table
true.table <- table(spnamur.sub)
# extracting the margins
tgt.v1        <- apply(true.table, 1, sum)
tgt.v1.v2     <- apply(true.table, c(1,2), sum)
tgt.v2.v3     <- apply(true.table, c(2,3), sum)
tgt.list.dims <- list(1, c(1,2), c(2,3))
tgt.data      <- list(tgt.v1, tgt.v1.v2, tgt.v2.v3)
# creating the seed, a 10% sample of spnamur
seed.df <- spnamur.sub[sample(nrow(spnamur), round(0.10*nrow(spnamur))), ]
seed.table <- table(seed.df)
# applying a fitting method
r.ipfp <- Estimate(seed=seed.table, target.list=tgt.list.dims, 
                   target.data = tgt.data,  method = "ipfp")
# print the maximum absolute deviation between targets and generated margins
print(error.margins(r.ipfp))
}
\keyword{univar}

\name{gof.estimates}
\alias{gof.estimates}
\alias{gof.estimates.default}
\alias{gof.estimates.mipfp}
\title{
Wald, Log-likelihood ratio and Person Chi-square statistics for mipfp object
}
\description{
This method computes three statistics to perform a test wheter the seed
agrees with the target data. The statistics are the Wilk's log-likelihood ratio
statistic, the Wald statistic and the Person Chi-square statistic.

The method also returns the associated degrees of freedom.
}
\usage{
\method{gof.estimates}{mipfp}(object, seed = NULL, target.data = NULL, 
              target.list = NULL, replace.zeros = 1e-10, ...)
}
\arguments{
  \item{object}{
    The object of class \code{mipfp} containing.
}
  \item{seed}{
    The seed used to compute the estimates (optional). If not provided, the
    method tries to determine the \code{seed} automatically.
}
  \item{target.data}{
    A list containing the data of the target margins. Each component of the 
    list is an array storing a margin. The list order must follow the one 
    defined in \code{target.list}. Note that the cells of the arrays must be 
    non-negative (and can even be NA if \code{method = ipfp}) (optional). 
    If not provided, the method tries to dermine \code{target.data}
    automatically.
}
  \item{target.list}{
    A list of the target margins provided in \code{target.data}. Each
    component of the list is an array whose cells indicates which dimension the 
    corresponding margin relates to (optional). If not provided, the method
    tries to determine \code{target.list} automatically.
}
  \item{replace.zeros}{
    If 0-cells are to be found, then they are replaced with this value.
}
  \item{\dots}{
    Not used.
}
}
\details{
The test is formally expressed as:
\deqn{H_0 ~ : ~ h(\pi) = 0 \quad vs \quad H_1~:~h(\pi) \neq 0}{%
H0 : h(p.seed) = 0 vs  H1 : h(p.seed) != 0}
where \eqn{\pi}{p.seed} is the vector of the seed probabilities and 
\eqn{h(x) = A^T x - m}{h(x) = t(A) * x - m} with \eqn{A} and \eqn{m} being
respectively the marginal matrix and the margins vector of the estimation
problem.

The three statistics are then defined as:
\itemize{
  \item Wilk's log-likelihoold ratio
    \deqn{G^2 = 2 \sum x_i \ln \frac{\pi_i}{\hat{\pi}_i}}{%
    G2 = 2 * \sum ( x.seed * ln (p.seed / p.hat) )}
  \item Wald's statistic
    \deqn{W^2 = h(x)^T ( H^T_x D_x H_x)^{-1} h(x)}{%
    W2 = t(h(x)) * inv(t(H) * diag(x.seed) * H) * h(x.seed)}
  \item Pearson Chi-square
    \deqn{\chi^2 = (x - n \hat{\pi})^T D^{-1}_{n\hat{\pi}} (x - n \hat{\pi})}{%
    X2 = t(x.seed - n * p.hat) * inv(diag(n * p.hat)) * (x.seed - n * p.hat)}
}
where \eqn{x}{x.seed} is the vectorization of the \code{seed}, 
\eqn{n = \sum x_i}{n = sum(x.seed)}, \eqn{D_v}{diag(v)} is a diagonal matrix 
derived from the vector \eqn{v}{v} and \eqn{H}{H} denotes the Jacobian evaluated 
in \eqn{\hat{\pi}}{p.hat} (the vector of the estimated probabilities) of the 
function \eqn{h(x)}{h(x)}.

The degrees of freedom for these statistics corresponds to the number of
components in \eqn{m}{m}.
}
\value{
A list whose elements are detailed below.
  \item{G2}{
    The Log-likelihood statistic.
}
  \item{W2}{
    The Wald statistic.
}
  \item{X2}{
    The Pearson chi-squared statistic.
}
  \item{stats.df}{
    The degrees of freedom for the \code{G2}, \code{W2} and 
    \code{X2} statistics.
}
}
\references{
 Lang, J.B. (2004) 
 Multinomial-Poisson homogeneous models for contingency tables. 
 \emph{Annals of Statistics} 32(1): 340-383.
}
\author{
Johan Barthelemy

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
\code{\link[mipfp:Estimate]{Estimate}} function to create an object of class
\code{mipfp} and to update an initial multidimensional array with respect to 
given constraints.
\code{\link[mipfp:summary.mipfp]{summary.mipfp}} can also retrieve the
statistics and their associated p-values.
}
\examples{
# loading the data
data(spnamur, package = "mipfp")
# subsetting the data frame, keeping only the first 3 variables
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
# true table
true.table <- table(spnamur.sub)
# extracting the margins
tgt.v1        <- apply(true.table, 1, sum)
tgt.v1.v2     <- apply(true.table, c(1,2), sum)
tgt.v2.v3     <- apply(true.table, c(2,3), sum)
tgt.list.dims <- list(1, c(1,2), c(2,3))
tgt.data      <- list(tgt.v1, tgt.v1.v2, tgt.v2.v3)
# creating the seed, a 10 pct sample of spnamur
seed.df <- spnamur.sub[sample(nrow(spnamur), round(0.10*nrow(spnamur))), ]
seed.table <- table(seed.df)
# applying one fitting method (ipfp)
r.ipfp <- Estimate(seed=seed.table, target.list=tgt.list.dims, 
                   target.data = tgt.data)
# printing the G2, X2 and W2 statistics
print(gof.estimates(r.ipfp))
# alternative way (pretty printing, with p-values)
print(summary(r.ipfp)$stats.gof)
}
\keyword{multivariate}
\keyword{htest}

\name{Corr2PairProbs}
\alias{Corr2PairProbs}
\title{Converting correlation to pairwise probability
}
\description{
For \eqn{K} binary (Bernoulli) random variables 
\eqn{X_1}{X_1}, ..., \eqn{X_K}{X_K}, this function transforms the correlation
measure of association \eqn{C_{ij}}{C_ij} between every pair 
\eqn{(X_i, X_j)}{(X_i, X_j)} to the pairwise probability 
\eqn{P(X_i = 1, X_j = 1)}{P(X_i = 1, X_j = 1)}, where \eqn{C_{ij}}{C_ij} is
defined as
\deqn{
C_{ij} = \frac{cov(X_i, X_j)}{\sqrt(var(X_i) * var(X_j))}.
}{
C_ij = cov(X_i, X_j) / sqrt(var(X_i) * var(X_j)).}
}
\usage{
Corr2PairProbs(corr, marg.probs)
}
\arguments{
  \item{corr}{
    A \eqn{K \times K}{K x K} matrix where the \eqn{i}-th row and the \eqn{j}-th
    column represents the correlation \eqn{C_{ij}}{C_ij} between variables
    \eqn{i} and \eqn{j}. 
}
  \item{marg.probs}{
    A vector with \eqn{K} elements of marginal probabilities where the 
    \eqn{i}-th entry refers to \eqn{P(X_i = 1)}{P(X_i = 1)}.
}
}

\value{
A matrix of the same dimension as \code{corr} containing the pairwise 
probabilities
}
\references{
  Lee, A.J. (1993).
  Generating Random Binary Deviates Having Fixed Marginal Distributions and 
  Specified Degrees of Association
  \emph{The American Statistician}  47 (3): 209-215.
 
  Qaqish, B. F., Zink, R. C., and Preisser, J. S. (2012). 
  Orthogonalized residuals for estimation of marginally specified association
  parameters in multivariate binary data.
  \emph{Scandinavian Journal of Statistics} 39, 515-527.
}
\author{
Thomas Suesse.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
\code{\link[mipfp:Odds2PairProbs]{Odds2PairProbs}} for converting odds ratio 
to pairwise probability.
}
\examples{
# correlation matrix from Qaqish et al. (2012)
corr <- matrix(c( 1.000, -0.215, 0.144, 0.107,
                 -0.215,  1.000, 0.184, 0.144,
                  0.144,  0.184, 1.000, 0.156,
                  0.107,  0.144, 0.156, 1.000), 
                  nrow = 4, ncol = 4, byrow = TRUE)
rownames(corr) <- colnames(corr) <- c("Parent1", "Parent2", "Sibling1", 
                                      "Sibling2")

# hypothetical marginal probabilities
p <- c(0.2, 0.4, 0.6, 0.8)

# getting the pairwise probabilities
pp <- Corr2PairProbs(cor = corr, marg.probs = p)
print(pp)
}
\concept{correlation}
\concept{odds ratio}
\concept{pairwise probability}
\concept{Bernoulli}
\keyword{multivariate}
\keyword{array}

\name{summary.mipfp}
\alias{summary.mipfp}
\alias{print.summary.mipfp}
\title{
Summarizing objects of class mipfp
}
\description{
Summary method for class \code{mipfp}.
}
\usage{
\method{summary}{mipfp}(object, cov.method = "delta", prop = FALSE, 
        target.list = NULL, l.names = 0, ...)

\method{print}{summary.mipfp}(x, ...)
}
\arguments{
  \item{object}{
    An object of class \code{mipfp}, usually a result of a call to
    \link[mipfp:Estimate]{Estimate}
}
  \item{x}{
    An object of class \code{summary.mipfp}, usually a result of a call to
    \code{summary.mipfp}.
}
  \item{cov.method}{
    Indicates which method to use to compute the covariance. Possible values 
    are Delta (\code{delta}, default) or Lang (\code{lang}).
}
  \item{prop}{
    If set to \code{FALSE} (the default), the results return counts, 
    probabilities otherwise.
}
  \item{target.list}{
    The list of the dimensions of the targets used by for the estimation
    process (see \link[mipfp:Estimate]{Estimate} for more details).
}
  \item{l.names}{
    If set to a value greater than 0, then the names of the
    categories will be shorten to a length of \code{l.names} characters.
}
  \item{\dots}{
    Further arguments passed to the underlying \code{print} and \code{flat} 
    method, or from other methods.
}
}
\details{
The function \code{summary.mipfp} compute and returns a list of summary
statistics of the estimates (covariance, t-statistics, goodness-of-fit
statistics, associated degrees of freedom).
}
\value{
The function \code{summary.mipfp} returns an object of class 
\code{summary.mipfp} having the following components:
  \item{call}{
    A \code{call} object in which all the specified arguments are given by
    their full names.
}
  \item{conv}{
     A Boolean indicating if the specified method converged to a 
     solution (\code{TRUE}) or not (\code{FALSE}).
}
  \item{method}{
    The method used to generate estimates.
}
  \item{df}{
    Degrees of freedom of the estimates.
}
  \item{estimates}{
    Estimates generated by the selected method with standard deviations and 
    associated t- and p-values.
}
  \item{error.margins}{
    A list returning, for each margin, the absolute maximum deviation between 
    the desired and generated margin.
}
  \item{vcov}{
    A covariance matrix of the estimates (last index move fastest) computed 
    using the method specified in \code{cov.method}.
}
  \item{tab.gof}{
    A table containing the Log-likelihood (G2), Wald (W2) and Pearson 
    chi-squared (X2) statistics with their associated p-values.
}
  \item{stats.df}{
    Degrees of freedom for the \code{G2}, \code{W2} and \code{X2} statistics.
}
  \item{dim.names}{
    Original dimension names of the estimated table.
}
  \item{l.names}{
    The value of the parameter \code{l.names}.
  }
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\note{
When using \code{print} for printing the resulting \code{mipfp} object, you can
also have a look at the options of the method \code{\link[mipfp:flat]{flat}}.
}
\seealso{
The estimation function \code{\link[mipfp:Estimate]{Estimate}}.

The function \code{\link[mipfp:coef.mipfp]{coef.mipfp}} to extract the 
estimates.

\code{\link[mipfp:gof.estimates]{gof.estimates}} for the computation of the 
\code{G2}, \code{W2} and \code{X2} statistics. 

\code{\link[mipfp:vcov.mipfp]{vcov.mipfp}} for the details of the covariance 
computation.
}
\examples{
# loading the data
data(spnamur, package = "mipfp")
# subsetting the data frame, keeping only the first 3 variables
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
# true table
true.table <- table(spnamur.sub)
# extracting the margins
tgt.v1        <- apply(true.table, 1, sum)
tgt.v1.v2     <- apply(true.table, c(1,2), sum)
tgt.v2.v3     <- apply(true.table, c(2,3), sum)
tgt.list.dims <- list(1, c(1,2), c(2,3))
tgt.data      <- list(tgt.v1, tgt.v1.v2, tgt.v2.v3)
# creating the seed, a 10 pct sample of spnamur
seed.df <- spnamur.sub[sample(nrow(spnamur), round(0.10*nrow(spnamur))), ]
seed.table <- table(seed.df)
# applying the different fitting methods
r.ipfp <- Estimate(seed=seed.table, target.list=tgt.list.dims, 
                   target.data = tgt.data)
# printing the summary                   
print(summary(r.ipfp))
}
\keyword{models}
\keyword{multivariate}
\keyword{array}
\concept{iterative proportional fitting procedure}
\concept{ipfp}
\concept{multiway contingency table update}
\concept{multiway contingency table estimation}
\concept{multivariate contingency table estimation}
\concept{RAS algorithm}
\concept{matrix raking}
\concept{matrix scaling}

\name{CompareMaxDev}
\alias{CompareMaxDev}
\title{
Comparing deviations of mipfp objects
}
\description{
This function compares either the margins errors from different \code{mipfp} 
objects or the absolute maximum deviation between a given table and the 
estimates in the mipfp objects.
}
\usage{
CompareMaxDev(list.mipfp = list(), true.table = NULL, echo = FALSE)
}
\arguments{
  \item{list.mipfp}{
    The list produced by the function \code{\link[mipfp:Estimate]{Estimate}}.
}
  \item{true.table}{
    When provided, the estimates contained in the \code{mipfp} objects in the 
    list \code{list.mipfp} are compared against this table. It is an optional
    argument.
}
  \item{echo}{
    Verbose parameter. If \code{TRUE}, the function prints what is being 
    compared. Default is \code{FALSE}.
}
}
\value{
A table with as many rows as the number of mipfp objects in \code{list.mipfp}. 
Each row details the margins errors or the maximum absolute deviation of 
one \code{mipfp} object.
}
\author{
Johan Barthelemy

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
The estimation function \code{\link[mipfp:Estimate]{Estimate}}.

This function is used by 
\code{\link[mipfp:error.margins.mipfp]{error.margins.mipfp}}.
}
\examples{
# loading the data
data(spnamur, package = "mipfp")
# subsetting the data frame, keeping only the first 3 variables
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
# true table
true.table <- table(spnamur.sub)
# extracting the margins
tgt.v1        <- apply(true.table, 1, sum)
tgt.v1.v2     <- apply(true.table, c(1,2), sum)
tgt.v2.v3     <- apply(true.table, c(2,3), sum)
tgt.list.dims <- list(1, c(1,2), c(2,3))
tgt.data      <- list(tgt.v1, tgt.v1.v2, tgt.v2.v3)
# creating the seed, a 10% sample of spnamur
seed.df <- spnamur.sub[sample(nrow(spnamur), round(0.10*nrow(spnamur))), ]
seed.table <- table(seed.df)
# applying the different fitting methods
r.ipfp <- Estimate(seed=seed.table, target.list=tgt.list.dims, 
                   target.data = tgt.data,  method = "ipfp")
r.ml   <- Estimate(seed = seed.table, target.list = tgt.list.dims, 
                   target.data = tgt.data, method = "ml")
r.chi2 <- Estimate(seed = seed.table, target.list = tgt.list.dims, 
                   target.data = tgt.data, method = "chi2")
r.lsq  <- Estimate(seed = seed.table, target.list = tgt.list.dims, 
                   target.data = tgt.data, method = "lsq")
# print the maximum absolute deviation between targets and generated margins
CompareMaxDev(list(r.ipfp,r.ml,r.chi2,r.lsq), echo = TRUE)
# compute the maximum absolute deviation between the true and estimated tables
CompareMaxDev(list(r.ipfp,r.ml,r.chi2,r.lsq), echo = TRUE, 
              true.table = true.table)
}
\keyword{univar}

\name{ObtainModelEstimates}
\alias{ObtainModelEstimates}
\title{Estimating a contingency table using model-based approaches
}
\description{This function provides several alternative estimating methods to 
the IPFP when estimating a multiway table subject to known constrains/totals: 
maximum likelihood method (ML), minimum chi-squared (CHI2) and weighted least 
squares (WLSQ). Note that the resulting estimators are probabilities.
   
The covariance matrix of the estimated proportions (as defined by Little and Wu, 
1991) are also provided. Also in the case of the ML method, the covariance 
matrix defined by Lang (2004) is also returned.

}
\usage{
ObtainModelEstimates(seed, target.list, target.data, method="ml", 
                     tol.margins = 1e-10, replace.zeros = 1e-10, ...)
}
\arguments{
 \item{seed}{
    The initial multi-dimensional array to be updated. Each cell must
    be non-negative.
}
  \item{target.list}{
    A list of the target margins provided in \code{target.data}. Each component
    of the list is an array whose cells indicates which dimension the
    corresponding margin relates to.
}
  \item{target.data}{
    A list containing the data of the target margins. Each
    component of the list is an array storing a margin.
    The list order must follow the one defined in \code{target.list}.
    Note that the cells of the arrays must be non-negative.
}
  \item{method}{Determine the model to be used for estimating the contingency
    table. By default the method is \code{ml} (maximum likelihood); other 
    options available are \code{chi2} (minimum chi-squared) and \code{lsq} 
    (least squares).
}
  \item{tol.margins}{
    Tolerance for the margins consistency. Default is \eqn{1e^{-10}}{1e-10}.
}
  \item{replace.zeros}{
    Constant that is added to zero cell found in the seed,
    as procedures require strictly positive cells. Default value is 
    \eqn{1e^{-10}}{1e-10}.
}
  \item{...}{Additional parameters that can be passed to control the 
    optimisation process (see \link[Rsolnp:solnp]{solnp} from the package 
    \link[Rsolnp]{Rsolnp}).
}
}
\value{
A list containing the final estimated table as well as the covariance matrix of
the estimated proportion and other convergence informations.
  \item{x.hat}{
    Array of the estimated table frequencies.
}
  \item{p.hat}{
    Array of the estimated table probabilities.
}
  \item{error.margins}{
    For each list element of \code{target.data}, \code{check.margins} shows the 
    maximum absolute deviation between the element and the corresponding 
    estimated margin. Note that the deviations should approximate zero, 
    otherwise the target margins are not met.
}
  \item{solnp.res}{
    The estimation process uses the \code{solnp} optimisation function from 
    the R package Rsolnp and \code{solnp.res} is the corresponding object 
    returned by the solver.
}
  \item{conv}{
    A boolean indicating whether the algorithm converged to a solution.
}
  \item{method}{
    The selected method for estimation.  
}
  \item{call}{
    The matched call.  
}
}
\references{
 Lang, J.B. (2004) 
 Multinomial-Poisson homogeneous models for contingency tables. 
 \emph{Annals of Statistics} 32(1): 340-383.

 Little, R. J., Wu, M. M. (1991)
 Models for contingency tables with known margins when target and sampled 
 populations differ.
 \emph{Journal of the American Statistical Association} 86 (413): 87-95.
}
\author{
Thomas Suesse 

Maintainer: Johan Barthelemy <johan@uow.edu.au>.
}
\note{
It is important to note that if the margins given in \code{target.list} are
not consistent (i.e. the sums of their cells are not equals), the input data
is then normalised by considering probabilities instead of frequencies:
\itemize{
  \item the cells of the seed are divided by \code{sum(seed)};
  \item the cells of each margin \code{i} of the list \code{target.data} are 
        divided by \code{sum(target.data[[i]])}.
}
}
\seealso{
\code{\link[Rsolnp:solnp]{solnp}} function documentation of the package
\code{\link[Rsolnp]{Rsolnp}} for the details of the \code{solnp.res} object 
returned by the function.
}
\examples{
# set-up an initial 3-way table of dimension (2 x 2 x 2)
seed <- Vector2Array(c(80, 60, 20, 20, 40, 35, 35, 30), dim = c(c(2, 2, 2)))

# building target margins
margins12 <- c(2000, 1000, 1500, 1800)
margins12.array <- Vector2Array(margins12, dim=c(2, 2))
margins3 <- c(4000,2300)
margins3.array <- Vector2Array(margins3, dim = 2) 
target.list <- list(c(1, 2), 3)
target.data <- list(margins12.array, margins3.array)

# estimating the new contingency table using the ml method
results.ml <- ObtainModelEstimates(seed, target.list, target.data, 
                                   compute.cov = TRUE)
print(results.ml)

# estimating the new contingency table using the chi2 method
results.chi2 <- ObtainModelEstimates(seed, target.list, target.data, 
                                     method = "chi2", compute.cov = TRUE)
print(results.chi2)

# estimating the new contingency table using the lsq method
results.lsq <- ObtainModelEstimates(seed, target.list, target.data,
                                    method = "lsq", compute.cov = TRUE)
print(results.lsq)
}
\concept{multiway contingency table estimation}
\concept{multivariate contingency table estimation}
\keyword{models}
\keyword{multivariate}
\keyword{array}

\name{mipfp-package}
\alias{mipfp-package}
\alias{mipfp}
\docType{package}
\title{
Multidimensional Iterative Proportional Fitting and Alternative Models
}
\description{
An implementation of several methods for updating an initial \eqn{N}-dimensional
array (called a seed) with respect to given target marginal distributions. 
Those targets can also be multi-dimensional. The procedures are also able to 
estimate a (multi-dimensional) contingency table (encoded as an array) 
matching a given set of (multi-dimensional) margins. In that case, each cell 
of the seed must simply be set to 1.

The package provides the iterative proportional fitting procedure (IPFP), also 
known as the RAS algorithm in economics and matrix raking or matrix scaling in 
computer science. Additionnaly several alternative estimating methods to 
the IPFP are also included, namely the maximum likelihood (ML), minimum 
chi-squared (CHI2) and weighted least squares (WLSQ) model-based approaches.

The package also includes an application of the IPFP to simulate and estimate 
the parameters of multivariate Bernoulli distributions.

Finally a function extracting the linearly independant columns from a matrix,
hence returning a matrix of full rank is provided.
}
\details{
\tabular{ll}{
Package: \tab mipfp\cr
Type: \tab Package\cr
Version: \tab 3.2.3\cr
Date: \tab 2026-08-22\cr
Depends: \tab cmm, numDeriv, Rsolnp, R(>= 2.10.0)\cr
License: \tab GPL-2\cr
}
This package provides an implementation of several fitting procedures for 
updating a \eqn{N}-dimensional array with respect to given target marginal 
distributions. Those targets can also multi-dimensional. The available methods
are listed herehunder.

\itemize{
  \item The function \code{\link[mipfp:Ipfp]{Ipfp}} provides the iterative 
    proportionnal fitting Procedure.
  \item Maximum likelihood, minimum Chi-square and weighted least squares
    approaches are availables in the function
    \link[mipfp:ObtainModelEstimates]{ObtainModelEstimates}.
}
The function \code{\link[mipfp:Estimate]{Estimate}} provides an interface to
these two methods. Each of them returns an object of class \code{mipfp}, but
\code{\link[mipfp:Estimate]{Estimate}} should be the preferred constructor.

The package provides several methods and functions to extract various 
information from the resulting object such as as the variance-covariance matrix 
of the estimated cell probabilities or counts using either the Lang's (2004) or 
the Delta method (Little and Wu, 1991) (\code{\link[mipfp:vcov.mipfp]{vcov}}),
the confidence interval of the estimates 
(\code{\link[mipfp:confint.mipfp]{confint}}), the comparison of the deviations
(\code{\link[mipfp:CompareMaxDev]{CompareMaxDev}}), etc. Note that the functions 
starting with a lower case are S3 methods for objects of class \code{mipfp} 
while the one starting with an upper case are general functions.

The package also includes an application of the IPFP to simulate and estimate 
the parameters of multivariate Bernoulli distributions, respectively in the
functions \code{\link[mipfp]{RMultBinary}} and 
\code{\link[mipfp]{ObtainMultBinaryDist}}. In addition, the functions 
\code{\link[mipfp]{Corr2Odds}}, \code{\link[mipfp]{Odds2Corr}}, 
\code{\link[mipfp]{Corr2PairProbs}}, \code{\link[mipfp]{Odds2PairProbs}} are in 
turn responsible for converting correlation to odds ratio, odds ratio to 
correlation, correlation to pairwise probability and odds ratio to pairwise 
probability.

Finally, auxillary functions are also provided. \code{\link[mipfp]{expand}} 
expands a multi-dimensional contingency table (stored in \code{table}) into a
data frame of individual recors. \code{\link[mipfp]{Array2Vector}} and 
\code{\link[mipfp]{Vector2Array}} transforms an array to a vector and 
vice-versa. \code{\link[mipfp:flat]{flat}} flattens multi-dimensional objects 
for pretty printing. The function \code{\link[mipfp]{GetLinInd}} extracting the 
linearly independant columns from a matrix (using QR decomposition) and 
returning a matrix of full rank is also provided. 
}
\author{
Johan Barthelemy and Thomas Suesse.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\references{
 Bacharach, M. (1965).
 Estimating Nonnegative Matrices from Marginal Data.
 \emph{International Economic Review} (Blackwell Publishing) 6 (3): 294-310.
 
 Barthelemy, J., Suesse, T. (2018).
 mipfp: An R Package for Multidimensional Array Fitting and Simulating Multivariate Bernoulli Distributions.
 \emph{Journal of Statistical Software, Code Snippets} 86 (2): 1-20, doi: 10.18637/jss.v086.c02.
 
 
 Bishop, Y. M. M., Fienberg, S. E., Holland, P. W. (1975).
 \emph{Discrete Multivariate Analysis: Theory and Practice.}
 MIT Press. ISBN 978-0-262-02113-5.
 
 Deming, W. E., Stephan, F. F. (1940).
 On a Least Squares Adjustment of a Sampled Frequency Table When the Expected
 Marginal Totals are Known.
 \emph{Annals of Mathematical Statistics} 11 (4): 427-444.
 
 Fienberg, S. E. (1970).
 An Iterative Procedure for Estimation in Contingency Tables.
 \emph{Annals of Mathematical Statistics} 41 (3): 907-917.

 Golub, G. H., Van Loan C. F. (2012)
 \emph{Matrix Computations. Third Edition.}
 Johns Hopkins University Press.

 Lang, J.B. (2004) 
 Multinomial-Poisson homogeneous models for contingency tables. 
 \emph{Annals of Statistics} 32(1): 340-383.

 Lee, A.J. (1993).
 Generating Random Binary Deviates Having Fixed Marginal Distributions and 
 Specified Degrees of Association
 \emph{The American Statistician}  47 (3): 209-215.
 
 Little, R. J., Wu, M. M. (1991)
 Models for contingency tables with known margins when target and sampled 
 populations differ.
 \emph{Journal of the American Statistical Association} 86 (413): 87-95.
 
 Qaqish, B. F., Zink, R. C., and Preisser, J. S. (2012). 
 Orthogonalized residuals for estimation of marginally specified association
 parameters in multivariate binary data.
 \emph{Scandinavian Journal of Statistics} 39, 515-527.
 
 Stephan, F. F. (1942).
 Iterative method of adjusting frequency tables when expected margins are known.
 \emph{Annals of Mathematical Statistics} 13 (2): 166-178.
}
\seealso{
 \code{ipfp} for a package implementing the ipfp to solve problems of the form
 \eqn{Ax = b}{Ax = b}.
}
\examples{
# generation of an intial 2-ways table to be updated
seed <- array(1, dim=c(2, 2))
# desired targets (margins)
target.row <- c(87, 13)
target.col <- c(52, 48)
# storing the margins in a list
target.data <- list(target.col, target.row)
# list of dimensions of each marginal constrain
target.list <- list(1, 2)
# calling the fitting methods
r.ipfp <- Ipfp(seed, target.list, target.data)
r.ml <- ObtainModelEstimates(seed, target.list, target.data, method = "ml")
r.chi2 <- ObtainModelEstimates(seed, target.list, target.data, method = "chi2")
r.lsq <- ObtainModelEstimates(seed, target.list, target.data, method = "lsq")
}
\concept{iterative proportional fitting procedure}
\concept{ipfp}
\concept{multiway contingency table update}
\concept{multivariate contingency table update}
\concept{RAS algorithm}
\concept{matrix raking}
\concept{matrix scaling}
\concept{Bernoulli}
\keyword{models}
\keyword{multivariate}
\keyword{array}
\keyword{distribution}
\keyword{package}

\name{vcov.mipfp}
\alias{vcov.mipfp}
\title{
Calculate variance-covariance matrix for mipfp objects
}
\description{
This function determines the (asymptotic) covariance matrix of the estimates 
in an \code{mipfp} object using either the Delta formula designed by Little 
and Wu (1991) or Lang's formula (2004).
}
\usage{
\method{vcov}{mipfp}(object, method.cov = "delta", seed = NULL, 
     target.data = NULL, target.list = NULL, replace.zeros = 1e-10, ...)
}
\arguments{
  \item{object}{
    An object of class mipfp.
}
  \item{method.cov}{
    Select the method to use for the computation of the covariance.
    The available methods are \code{delta} and \code{lang}.
}
  \item{seed}{
    The initial multi-dimensional array used to create \code{object}
    (optional). 
}
  \item{target.data}{
    A list containing the data of the target margins used to create 
    \code{object}. Each component of the list is an array storing a margin. 
    The list order must follow the one defined in \code{target.list}
    (optional).
}
  \item{target.list}{
    A list of the target margins used to create \code{object} function. Each
    component of the list is an array whose cells indicates which dimension the
    corresponding margin relates to (optional).
}
  \item{replace.zeros}{
    If 0-cells are to be found, then their values are replaced with this
    value.
}
  \item{...}{
    Not used.  
}
}
\details{
The asymptotic covariance matrix of the estimates probabilities using Delta's 
formula has the form (Little and Wu, 1991)
\deqn{K(K^T D1^{-1} K)^{-1} K^T D2^{-1} K (K^T D1^{-1} K)^{-1} K^T}{
      K * inv(t(K) * inv(D1) * K) * t(K) * inv(D2) * K * inv(t(K) * inv(D1)
      * K) * t(K)}
where
\itemize{
  \item{\code{K} is the orthogonal complement of the marginal matrix, i.e. the 
    matrix \eqn{A}{A} required to obtain the marginal frequencies \eqn{m}{m};
}
  \item{\code{D1} and \code{D2} are two diagonal matrices whose components
    depends on the estimation process used to generate \code{object}.
}
}
If the estimation process has been done using
\itemize{
  \item \code{ipfp}
    then \eqn{diag(D1) = \hat{p}}{diag(D1) = p.hat} and 
    \eqn{diag(D2) = p_*}{diag(D2) = p.seed};
  \item \code{ml}
    then \eqn{diag(D1) = \frac{\hat{p}^2}{p_*}}{diag(D1) = p.hat^2 / p.seed} and 
    \eqn{diag(D2) = diag(D1)}{diag(D2) = diag(D1)};
  \item \code{chi2}
    then \eqn{diag(D1) = \frac{\hat{p}^4}{p_*^3}}{diag(D1) = p.hat^4 / p.seed^3}
    and \eqn{diag(D2) = diag(D1)}{diag(D2) = diag(D1)};
  \item \code{lsq}
    then \eqn{diag(D1) = p_*}{diag(D1) = p.seed} and 
    \eqn{diag(D2) = \frac{p_*3}{\hat{p}^2}}{diag(D2) = p.seed^3 / p.hat^2};
}
where \eqn{\hat{p}}{p.hat} is the vector of estimated probabilities and
\eqn{p_*}{p.seed} is the vector of the seed probabilities.

Using Lang's formula (2004), the covariance matrix becomes
\deqn{\frac{1}{N} 
      \left( D - \hat{p}\hat{p}^T - D H(H^T D H)^{-1} H^T D \right)}{%
      1/N (D - p.hat * t(p.hat) - D * H * inv(t(H) * D * H) * t(H) * D) }
where
\itemize{
  \item \code{D}
    is a diagonal matrix of the estimated probabilities \eqn{\hat{p}}{p.hat};
  \item \code{H}
    denotes the Jacobian evaluated in \eqn{\hat{p}}{p.hat} of the function
    \eqn{h(p) = A^T p - m}{h(p) = t(A) * p - m}.
}
}
\value{
A list with the following components:
  \item{x.hat.cov}{
    A covariance matrix of the estimated counts (last index move fastest)
    computed using the method specified in \code{cov.method}.
}
  \item{p.hat.cov}{
    A covariance matrix of the estimated probabilities (last index 
    move fastest) computed using the method specified in \code{cov.method}.
}
  \item{x.hat.se}{
    The standard deviation of the estimated counts (last index move fastest)
    computed using the method specified in \code{cov.method}.
}
  \item{p.hat.se}{
    The standard deviation of the estimated probabilities (last index move 
    fastest) computed using the method specified in \code{cov.method}.
}
  \item{df}{
    Degrees of freedom of the estimates.
}
  \item{method.cov}{
    The method used to compute the covariance matrix.
}
}
\references{
 Lang, J.B. (2004) 
 Multinomial-Poisson homogeneous models for contingency tables. 
 \emph{Annals of Statistics} 32(1): 340-383.

 Little, R. J., Wu, M. M. (1991)
 Models for contingency tables with known margins when target and seed 
 populations differ.
 \emph{Journal of the American Statistical Association} 86 (413): 87-95.
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
\code{\link[mipfp:Estimate]{Estimate}} function to create an object of class
\code{mipfp} and to update an initial multidimensional array with respect to 
given constraints.
}
\examples{
# true contingency (2-way) table
true.table <- array(c(43, 44, 9, 4), dim = c(2, 2))
# generation of sample, i.e. the seed to be updated
seed <- ceiling(true.table / 10)
# desired targets (margins)
target.row <- apply(true.table, 2, sum)
target.col <- apply(true.table, 1, sum)
# storing the margins in a list
target.data <- list(target.col, target.row)
# list of dimensions of each marginal constrain
target.list <- list(1, 2)
# calling the Estimate function
res <- Estimate(seed, target.list, target.data)
# printing the variance-covariance matrix
print(vcov(res))
}
\concept{multiway contingency table estimation}
\concept{multivariate contingency table estimation}
\concept{variance-covariance matrix}
\concept{covariance}
\keyword{models}
\keyword{multivariate}
\keyword{array}

\name{GetLinInd}
\alias{GetLinInd}
\title{
Extracting the linearly independant columns from a matrix
}
\description{
Extracts the linearly dependant columns of matrix to obtain a matrix of full
rank using QR decomposition.
}
\usage{
GetLinInd(mat, tol = 1e-10)
}
\arguments{
  \item{mat}{
    The matrix possibly containing linearly dependant columns
}
  \item{tol}{
    Rank estimation tolerance. Default is \eqn{1e^{-10}}{1e-10}.
}
}
\value{
  A list containing the new matrix and the index of the selected colums.
  \item{mat.li}{
    A matrix made of the linearly independant columns of \code{mat}.
}
  \item{idx}{
    The index of the selected columns.    
}
}
\references{
 Golub, G. H., Van Loan C. F. (2012)
 \emph{Matrix Computations. Third Edition.}
 Johns Hopkins University Press.
}
\author{
Johan Barthelemy

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
\code{\link[base:qr]{qr}}.
}
\examples{
# generation of a matrix with linearly dependant columns
A <- matrix(c(1, 2, 3,
              1, 2, 4,
              1, 2, 8), nrow = 3, ncol = 3, byrow = TRUE)
              
# extracting and printing the linearly independant columns
B <- GetLinInd(A)
print(B)
}
\keyword{array}
\keyword{algebra}

\name{GetConfInt}
\alias{GetConfInt}
\title{
Computing confidence intervals for the estimated counts and probabilities
(deprecated)
}
\description{
This function computes the (asymptotic) Wald confidence intervals at a given 
significance level for the results generated by \code{\link[mipfp:Ipfp]{Ipfp}}
and \code{\link[mipfp:ObtainModelEstimates]{ObtainModelEstimates}} (provided 
that their option \code{compute.cov} was set to \code{TRUE}).
}
\usage{
GetConfInt(list.est, alpha = 0.05)
}
\arguments{
  \item{list.est}{
    A list produced either by \code{\link[mipfp:Ipfp]{Ipfp}} or 
    \code{\link[mipfp:ObtainModelEstimates]{ObtainModelEstimates}} containing
    the estimated counts and probabilities as well as their associated
    standard deviations.
}
  \item{alpha}{
    Significance level of the confidence interval corresponding to the
    100(1 - \eqn{\alpha}{\alpha})\% confidence level.
}
}
\details{
The confidence interval of the estimates \eqn{\hat{X}}{X.hat}, at significance
level \eqn{\alpha}{\alpha} is given by
\deqn{\hat{X} \pm z \left( 1-\frac{\alpha}{2} \right) * 
\hat{\sigma}}{X.hat +/- z(1-\alpha/2) * \sigma.hat}
where \eqn{\hat{\sigma}}{\sigma.hat} is the standart deviations of 
\eqn{\hat{X}}{X.hat} and \eqn{z}{z} is the inverse of the cumulative 
distribution function of the standard normal distribution.
}
\value{
  A list of matrices containing the upper and lower bounds for the estimated
  counts and probabilities.
  \item{lower.x}{
    Lower bounds of the confidence interval for \code{list.est$x.hat}.
}
  \item{upper.x}{
    Upper bounds of the confidence interval for \code{list.est$x.hat}.
}
  \item{lower.p}{
    lower bounds of the confidence interval for \code{list.est$p.hat}.
}
  \item{upper.p}{
    upper bounds of the confidence interval for \code{list.est$p.hat}.
}
}
\references{
 Smithson, M. (2002).
 \emph{Confidence intervals}.
 Sage Publications.
}
\author{
Johan Barthelemy

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\section{Warning}{
Note: this function is deprecated, instead use
\code{\link[mipfp:confint.mipfp]{confint.mipfp}}.
}
\seealso{
\code{\link[mipfp:Estimate]{Estimate}}, \code{\link[mipfp:Ipfp]{Ipfp}} and 
\code{\link[mipfp:ObtainModelEstimates]{ObtainModelEstimates}} to generate the
inputs for this function.

The S3 method \code{\link[mipfp:confint.mipfp]{confint.mipfp}} for object of 
class \code{mipfp}.
}
\examples{
# true contingency (2-way) table
true.table <- array(c(43, 44, 9, 4), dim = c(2, 2))
# generation of sample, i.e. the seed to be updated
seed <- ceiling(true.table / 10)
# desired targets (margins)
target.row <- apply(true.table, 2, sum)
target.col <- apply(true.table, 1, sum)
# storing the margins in a list
target.data <- list(target.col, target.row)
# list of dimensions of each marginal constrain
target.list <- list(1, 2)
# calling the Ipfp function
res <- Ipfp(seed, target.list, target.data)
# addint the standart deviations to res (required by GetConfInt)
cov.res <- vcov(res, seed = seed, target.list = target.list, 
                target.data = target.data)
res$p.hat.se <- cov.res$p.hat.se
res$x.hat.se <- cov.res$x.hat.se
# computing and printing the confidence intervals
print(GetConfInt(res))
}
\concept{confidence interval}
\keyword{multivariate}

\name{Array2Vector}
\alias{Array2Vector}
\title{
Transforming an array to a vector
}
\description{
Transform a N-dimensional array a to vector. The transformation is done
assuming that the last index of the array moves fastest. For instance, an array
\eqn{a} of dimensions (2,2,2) will produce the vector
\eqn{v = (a_{111}, a_{112}, a_{113}, a_{121}, a_{122},\ldots,a_{333})}{
v = ( a[1,1,1], a[1,1,2], a[1,1,3], a[1,2,1], a[1,2,2],\ldots,a[3,3,3])}.
}
\usage{
Array2Vector(arr)
}
\arguments{
  \item{arr}{
    The array to be transformed.
}
}
\value{
A vector filled with the data of the input array \code{arr}.
}
\author{
Thomas Suesse.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
The inverse transformation is performed with the function
\code{\link[mipfp:Vector2Array]{Vector2Array}}
}
\examples{
# generating an array of dimension (3,3,3)
a <- array(seq(1:27),dim=c(3,3,3))
# transforming it into a vector
v <- Array2Vector(a)
}

\keyword{vector}
\keyword{array}
\keyword{manip}
\keyword{utilities}

\name{Vector2Array}
\alias{Vector2Array}
\title{
Transforming a vector to an array
}
\description{
Transform a vector into a multidimensional array. The transformation is done
assuming that the last index of the array moves fastest. For instance, the
relation between a vector \eqn{v} of lenght 8 and an array \eqn{a} of dimensions
(2,2,2) is defined by \eqn{v = (a_{111}, a_{112}, a_{113}, a_{121}, a_{122},
\ldots,a_{333}}{ v = ( a[1,1,1], a[1,1,2], a[1,1,3], a[1,2,1], a[1,2,2],
\ldots,a[3,3,3] )}.
}
\usage{
Vector2Array(vect, dim.out)
}
\arguments{
  \item{vect}{
    The vector of length one or more to be transformed into an array.
}
  \item{dim.out}{
    The dimension attribute for the array to be created, that is an integer 
    vector of length one or more giving the maximal indices in each dimension.    
}
}
\value{
An array of dimensions given by \code{dim.out} filled with the data from the
input vector \code{vec}.
}
\author{
Thomas Suesse.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
The inverse transformation is performed with the function 
\code{\link[mipfp:Array2Vector]{Array2Vector}}.
}
\examples{
# generate a vector [1,2,...,27]
v <- seq(1:27)
# transform it into an array of dimension (3,3,3)
a <- Vector2Array(v,c(3,3,3))
}
\keyword{vector}
\keyword{array}
\keyword{manip}
\keyword{utilities}

\name{flat}
\alias{flat}
\alias{flat.default}
\alias{flat.table}
\alias{flat.array}
\alias{flat.matrix}

\title{
Flatten a table, array or matrix
}
\description{
This function takes a multidimensional object and flattens it for a pretty 
printing. The row names are the concatenation of the original dimension names 
while the only column stores the initial data of the object.
}
\usage{
\method{flat}{array}(x, sep = ".", label = "value", l.names = 0, ...)

\method{flat}{table}(x, sep = ".", label = "value", l.names = 0, ...)

\method{flat}{matrix}(x, sep = ".", label = "value", l.names = 0, ...)
}
\arguments{
  \item{x}{ 
    An array, table or matrix.
}
  \item{sep}{
    The separator used to concatenate the dimension names.
}
  \item{label}{
    The name of the column storing the data.
}
  \item{l.names}{
    If set to a value greater than 0, then the dimnames will be shorten to
    a length of \code{l.names} characters.
}
  \item{\dots}{
    Not used.
}
}
\value{
An array containing a flattened version of \code{x}.
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\note{
The function is inspired from the function \code{wrap.array} from the package 
\code{R.utils} written by Henrik Bengtsson.
}
\seealso{
The function \code{wrap.array} from the \code{R.utils} package
(\url{https://cran.r-project.org/package=R.utils}).
}
\examples{
# loading the data and saving in a 3D-table
data(spnamur, package = "mipfp")
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
tab <- table(spnamur.sub)

# flattening the table
tab.flat <- flat(tab)
print(tab.flat)
}
\keyword{methods}
\keyword{programming}

\name{coef.mipfp}
\alias{coef.mipfp}

\title{
Extract the coefficients of the estimates from an object of class mipfp
}
\description{
This method extracts the coefficients of estimates of an mipfp object.
}
\usage{
\method{coef}{mipfp}(object, prop = FALSE, ...)
}
\arguments{
  \item{object}{
    An object of class \code{mipfp}
}
  \item{prop}{
    If this Boolean is set to \code{TRUE} then the method will return
    the estimated probabilities. Otherwise, it will return the estimated counts.
    Default is \code{False}.
}
  \item{...}{
    Not used.  
}
}
\value{
Coefficients of the estimates extracted from the \code{mipfp} object 
\code{object}.
}
\references{
 Chambers, J. M. and Hastie, T. J. (1992)
 \emph{Statistical Models in S.}
 Wadsworth & Brooks/Cole.
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}

\seealso{
\code{\link[stats:coef]{coef}}.
}
\examples{
# loading the data
data(spnamur, package = "mipfp")
# subsetting the data frame, keeping only the first 3 variables
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
# true table
true.table <- table(spnamur.sub)
# extracting the margins
tgt.v1        <- apply(true.table, 1, sum)
tgt.v1.v2     <- apply(true.table, c(1,2), sum)
tgt.v2.v3     <- apply(true.table, c(2,3), sum)
tgt.list.dims <- list(1, c(1,2), c(2,3))
tgt.data      <- list(tgt.v1, tgt.v1.v2, tgt.v2.v3)
# creating the seed, a 10 pct sample of spnamur
seed.df <- spnamur.sub[sample(nrow(spnamur), round(0.10*nrow(spnamur))), ]
seed.table <- table(seed.df)
# estimating a table using ipfp
r.ipfp <- Estimate(seed=seed.table, target.list=tgt.list.dims, 
                   target.data = tgt.data)
# exctracting and printing the coefficient of the estimates
print(coef(r.ipfp))
}
\keyword{multivariate}

\name{Ipfp}
\alias{Ipfp}
\title{
Multidimensional Iterative Proportional Fitting
}
\description{
This function implements the iterative proportional fitting (IPFP) procedure. 
This procedure updates an initial N-dimensional array (referred as the seed) 
with respect to given target marginal distributions. Those targets can also 
be multi-dimensional. This procedure is also able to 
estimate a (multi-dimensional) contingency table (encoded as an array) matching 
a given set of (multi-dimensional) margins. In that case, each cell of the seed 
must simply be set to 1.

The IPFP is also known as the RAS algorithm in economics and matrix raking or 
matrix scaling in computer science.
}
\usage{
Ipfp(seed, target.list, target.data, print = FALSE, iter = 1000, tol = 1e-10,
     tol.margins = 1e-10, na.target = FALSE)
}
\arguments{
  \item{seed}{
    The initial multi-dimensional array to be updated. Each cell must
    be non-negative.
}
  \item{target.list}{
    A list of dimensions of the marginal target constrains in
    \code{target.data}. Each component of the list is an array whose cells 
    indicate which dimension the corresponding margin relates to.
}    
  \item{target.data}{
    A list containing the data of the target marginal tables. Each
    component of the list is an array storing a margin.
    The list order must follow the ordering defined in \code{target.list}.
    Note that the cells of the arrays must be non-negative.
}
  \item{print}{
    Verbose parameter: if TRUE prints the current iteration number
    and the associated value of the stopping criterion. Default is FALSE.
}
  \item{iter}{
    Stopping criterion. The maximum number of iteration allowed; 
    must be greater than 0. Default is 1000.
}
  \item{tol}{
    Stopping criterion. If the maximum absolute difference between two iteration
    is lower than the value specified by \code{tol}, then ipfp has reached 
    convergence; must be greater than 0. Default is \eqn{1e^{-10}}{1e-10}.
}
  \item{tol.margins}{
    Tolerance for the margins consistency. Default is \eqn{1e^{-10}}{1e-10}.
}
  \item{na.target}{
    If set to TRUE, allows the targets to have NA cells. Note that in that 
    particular case the margins consistency is not checked.
}
}
\value{
A list containing the final updated array as well as other convergence
informations.
  \item{x.hat}{
    An array with the same dimension of \code{seed} whose margins match those
    specified in \code{target.list}.
}
  \item{p.hat}{
    An array with the same dimension of \code{x.hat} containing the updated
    cell probabilities, i.e. \code{x.hat / sum(x.hat)}.
}
  \item{evol.stp.crit}{
    The evolution of the stopping criterion over the iterations.
}
  \item{conv}{
    A boolean indicating whether the algorithm converged to a solution.
}
  \item{error.margins}{
    A list returning, for each margin, the absolute maximum deviation between 
    the desired and generated margin.
}
  \item{method}{
    The selected method for estimation (here it will always be \code{ipfpf}).  
}
  \item{call}{
    The matched call.  
}
}
\references{
 Bacharach, M. (1965).
 Estimating Nonnegative Matrices from Marginal Data.
 \emph{International Economic Review} (Blackwell Publishing) 6 (3): 294-310.

 Bishop, Y. M. M., Fienberg, S. E., Holland, P. W. (1975).
 \emph{Discrete Multivariate Analysis: Theory and Practice.}
 MIT Press. ISBN 978-0-262-02113-5.

 Deming, W. E., Stephan, F. F. (1940).
 On a Least Squares Adjustment of a Sampled Frequency Table When the Expected
 Marginal Totals are Known.
 \emph{Annals of Mathematical Statistics} 11 (4): 427-444.
 
 Fienberg, S. E. (1970).
 An Iterative Procedure for Estimation in Contingency Tables.
 \emph{Annals of Mathematical Statistics} 41 (3): 907-917.
  
 Stephan, F. F. (1942).
 Iterative method of adjusting frequency tables when expected margins are known.
 \emph{Annals of Mathematical Statistics} 13 (2): 166-178.
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\note{
It is important to note that if the margins given in \code{target.list} are
not consistent (i.e. the sums of their cells are not equals), the input data
is then normalised by considering probabilities instead of frequencies:
\itemize{
  \item the cells of the seed are divided by \code{sum(seed)};
  \item the cells of each margin \code{i} of the list \code{target.data} are 
        divided by \code{sum(target.data[[i]])}.
}
}
\seealso{
The documentation of \code{\link[mipfp:IpfpCov]{IpfpCov}} provide details on the
the covariance matrices determination.
 
\code{\link[mipfp:ObtainModelEstimates]{ObtainModelEstimates}} for alternatives 
to the IPFP.
}
\examples{
# Example 1: 2-way table (V1,V2) of dim=(2,2)
# generating an intial 2-way table to be updated
seed.2d <- array(1,dim=c(2,2))
# desired targets (margins) : V1 and V2
target.row <- c(50,50)
target.col <- c(30,70)
# storing the margins in a list
tgt.data.2d <- list(target.col, target.row)
# list of dimensions of each marginal constrain
tgt.list.2d <- list(1,2)
# calling the Ipfp function
res.2d <- Ipfp(seed.2d, tgt.list.2d, tgt.data.2d)

# Example 2: 3-way table (V1,V2,V3) of dim=(2,4,2)
# seed
seed.3d <- array(1,c(2,4,2))
seed.3d[1,1,1] <- 4
seed.3d[1,3,1] <- 10
seed.3d[1,4,2] <- 6
# desired targets (margins) : V1 and (V2,V3)
target.V1 <- c(50, 16)
target.V2.V3 <- array(4, dim=c(4,2))
target.V2.V3[1,1] <- 10
target.V2.V3[3,1] <- 22
target.V2.V3[4,2] <- 14
# list of dimensions of each marginal constrain
tgt.data.3d <- list(target.V1, target.V2.V3)
# storing the description of target data in a list
tgt.list.3d <- list( 1, c(2,3) )
# calling the Ipfp function
res.3d <- Ipfp(seed.3d, tgt.list.3d, tgt.data.3d, iter=50, print=TRUE, tol=1e-5)

# Example 3: 2-way table (V1,V2) of dim=(2,3) with missing values in the targets
# generating an intial 2-way table to be updated
seed.2d.na <- array(1,dim=c(2,3))
# desired targets (margins) : V1 and V2
target.row.na <- c(40,60)
target.col.na <- c(NA,10,NA)
# storing the margins in a list
tgt.data.2d.na <- list(target.row.na, target.col.na)
# storing the description of target data in a list
tgt.list.2d.na <- list(1,2)
# calling the Ipfp function
res.2d.na <- Ipfp(seed.2d.na, tgt.list.2d.na, tgt.data.2d.na, na.target=TRUE)
}
\concept{iterative proportional fitting procedure}
\concept{ipfp}
\concept{multiway contingency table update}
\concept{multivariate contingency table estimation}
\concept{RAS algorithm}
\concept{matrix raking}
\concept{matrix scaling}
\keyword{models}
\keyword{multivariate}
\keyword{array}

\name{ComputeA}
\alias{ComputeA}
\title{
Computes the marginal matrix A and margins vector m of an estimation problem
}
\description{
Given a set of marginal target constraints and the dimension of the array
\eqn{X}{X} to wich the targets relate to, this function computes the matrix 
\eqn{A}{A} of full rank and vector \eqn{m}{m} such that
\deqn{A^T \pi = (m, 1)^T}{t(A) * p = t(c(m, 1)) }
where vector \eqn{m}{m} contains all components but one of every target and
\eqn{\pi}{p} is a vector of the (unknow) components of \eqn{X}.
}
\usage{
ComputeA(dim.arr, target.list, target.data)
}
\arguments{
  \item{dim.arr}{
    The dimension of the array \eqn{X} to which the margins are applied.
}
  \item{target.list}{
    A list of the target margins provided in target.data. Each 
    component of the list is an array whose cells indicates which
    dimension the corresponding margin relates to.
}
  \item{target.data}{
    A list containing the data of the target margins. Each 
    component of the list is an array storing a margin. The list 
    order must follow the one defined in target.list. Note that 
    the cells of the arrays must be non-negative.
}
}
\value{
A list whose elements are defined below.
  \item{marginal.matrix}{
    The marginal matrix.
}
  \item{margins}{
    A vector containing the margins associated with A.
}
  \item{df}{
    The degree of freedom of the problem.
}
}
\author{
Johan Barthelemy

Maintainer: Johan Barthelemy <johan@uow.edu.au>.
}
\seealso{
\code{\link[cmm:MarginalMatrix]{MarginalMatrix}}.
}
\examples{
# loading the data
data(spnamur, package = "mipfp")
# subsetting the data frame, keeping only the first 3 variables
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
# true table
true.table <- table(spnamur.sub)
# extracting the margins
tgt.v1        <- apply(true.table, 1, sum)
tgt.v1.v2     <- apply(true.table, c(1,2), sum)
tgt.v2.v3     <- apply(true.table, c(2,3), sum)
tgt.list.dims <- list(1, c(1,2), c(2,3))
tgt.data      <- list(tgt.v1, tgt.v1.v2, tgt.v2.v3)
# creating the seed, a 10 pct sample of spnamur
seed.df <- spnamur.sub[sample(nrow(spnamur), round(0.10*nrow(spnamur))), ]
seed.table <- table(seed.df)
# computing the associated marginal matrix and margins vector
res.marg <- ComputeA(dim(seed.table), tgt.list.dims, tgt.data)
print(res.marg)
}
\keyword{array}
\keyword{algebra}

\name{Estimate}
\alias{Estimate}
\alias{print.mipfp}
\title{
Update an N-way table given target margins
}
\description{
This function provides several estimating methods to up multiway table 
(referred as the seed) subject to known constrains/totals: Iterative 
proportional fitting procedure (ipfp), maximum likelihood method (ml), minimum 
chi-squared (chi2) and weighted least squares (lsq). Note that the targets can 
also be multi-dimensional.
}
\usage{
Estimate(seed, target.list, target.data, method = "ipfp", keep.input = FALSE,
         ...)
}
\arguments{
  \item{seed}{
    The initial multi-dimensional array to be updated. Each cell must
    be non-negative if \code{method} is \code{ipfp} or strictly positive
    when \code{method} is \code{ml}, \code{lsq} or \code{chi2}.
}
  \item{target.list}{
    A list of dimensions of the marginal target constrains in
    \code{target.data}. Each component of the list is an array whose cells 
    indicate which dimension the corresponding margin relates to.
}
  \item{target.data}{
    A list containing the data of the target marginal tables. Each
    component of the list is an array storing a margin.
    The list order must follow the ordering defined in \code{target.list}.
    Note that the cells of the arrays must be non-negative.
}
  \item{method}{
    An optional character string indicating which method is to be used to
    update the \code{seed}. This must be on of the strings "ipfp", "ml",
    "chi2", or "lsq". Default is "ipfp".
}
  \item{keep.input}{
    A Boolean indicating if \code{seed}, \code{target.data} and 
    \code{target.list} when set to \code{TRUE}.
}
  \item{\dots}{
    Additionals argument that can be passed to the functions 
    \link[mipfp:Ipfp]{Ipfp} and 
    \link[mipfp:ObtainModelEstimates]{ObtainModelEstimates}. See their 
    respective documentation for more details.
}
}
\value{
An object of class \code{mipfp} is a list containing at least the 
following components:
  \item{x.hat}{
    An array with the same dimension of \code{seed} whose margins match those
    specified in \code{target.list}.
}
  \item{p.hat}{
    An array with the same dimension of \code{x.hat} containing the updated
    cell probabilities, i.e. \code{x.hat / sum(x.hat)}.
}
  \item{error.margins}{
    A list returning, for each margin, the absolute maximum deviation between 
    the desired and generated margin.
}
  \item{conv}{
    A boolean indicating whether the algorithm converged to a solution.
}
 \item{evol.stp.crit}{
    The evolution of the stopping criterion over the iterations (if selected
    \code{method} is \code{"ipfp"})).
}
  \item{solnp.res}{
    The estimation process uses the \code{solnp} optimisation function from 
    the R package Rsolnp and \code{solnp.res} is the corresponding object 
    returned by the solver (if selected \code{method} is not \code{"ipfp"}).
}
  \item{method}{
    The selected method for estimation.
}
  \item{call}{
    The matched call.  
}

The will be also added if \code{keep.input} has been set to \code{TRUE}: 
\code{seed}, \code{target.data}, \code{target.list}.

}
\references{
 Bacharach, M. (1965).
 Estimating Nonnegative Matrices from Marginal Data.
 \emph{International Economic Review} (Blackwell Publishing) 6 (3): 294-310.

 Bishop, Y. M. M., Fienberg, S. E., Holland, P. W. (1975).
 \emph{Discrete Multivariate Analysis: Theory and Practice.}
 MIT Press. ISBN 978-0-262-02113-5.

 Deming, W. E., Stephan, F. F. (1940).
 On a Least Squares Adjustment of a Sampled Frequency Table When the Expected
 Marginal Totals are Known.
 \emph{Annals of Mathematical Statistics} 11 (4): 427-444.
 
 Fienberg, S. E. (1970).
 An Iterative Procedure for Estimation in Contingency Tables.
 \emph{Annals of Mathematical Statistics} 41 (3): 907-917.
  
 Little, R. J., Wu, M. M. (1991)
 Models for contingency tables with known margins when target and sampled 
 populations differ.
 \emph{Journal of the American Statistical Association} 86 (413): 87-95.
 
 Lang, J.B. (2004) 
 Multinomial-Poisson homogeneous models for contingency tables. 
 \emph{Annals of Statistics} 32(1): 340-383.
  
 Stephan, F. F. (1942).
 Iterative method of adjusting frequency tables when expected margins are known.
 \emph{Annals of Mathematical Statistics} 13 (2): 166-178.
}
\author{
Johan Barthelemy.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\note{
It is important to note that if the margins given in \code{target.list} are
not consistent (i.e. the sums of their cells are not equals), the input data
is then normalised by considering probabilities instead of frequencies:
\itemize{
  \item the cells of the seed are divided by \code{sum(seed)};
  \item the cells of each margin \code{i} of the list \code{target.data} are 
        divided by \code{sum(target.data[[i]])}.
}
}
\seealso{
See the functions \code{\link[mipfp:Ipfp]{Ipfp}} and 
\code{\link[mipfp:ObtainModelEstimates]{ObtainModelEstimates}}
for more details about the estimation process.

\code{\link[mipfp:summary.mipfp]{summary.mipfp}} for summaries,  
\code{\link[mipfp:vcov.mipfp]{vcov.mipfp}} for the (asymptotic) covariance of 
the estimates and \code{\link[mipfp:gof.estimates.mipfp]{gof.estimates.mipfp}}
for testing if the seed agrees with the targets.

The genereric functions \code{\link[mipfp:print.mipfp]{print}} and
\code{\link[mipfp:coef.mipfp]{coef}}.
}
\examples{
# loading the data
data(spnamur, package = "mipfp")
# subsetting the data frame, keeping only the first 3 variables
spnamur.sub <- subset(spnamur, select = Household.type:Prof.status)
# true table
true.table <- table(spnamur.sub)
# extracting the margins
tgt.v1        <- apply(true.table, 1, sum)
tgt.v1.v2     <- apply(true.table, c(1,2), sum)
tgt.v2.v3     <- apply(true.table, c(2,3), sum)
tgt.list.dims <- list(1, c(1,2), c(2,3))
tgt.data      <- list(tgt.v1, tgt.v1.v2, tgt.v2.v3)
# creating the seed, a 10 pct sample of spnamur
seed.df <- spnamur.sub[sample(nrow(spnamur), round(0.10*nrow(spnamur))), ]
seed.table <- table(seed.df)
# applying one fitting method (ipfp)
r.ipfp <- Estimate(seed=seed.table, target.list=tgt.list.dims, 
                   target.data = tgt.data)
print(r.ipfp)
}
\keyword{models}
\keyword{multivariate}
\keyword{array}
\concept{iterative proportional fitting procedure}
\concept{ipfp}
\concept{multiway contingency table update}
\concept{multiway contingency table estimation}
\concept{multivariate contingency table estimation}
\concept{RAS algorithm}
\concept{matrix raking}
\concept{matrix scaling}

\name{ObtainMultBinaryDist}
\alias{ObtainMultBinaryDist}
\title{Generating a multivariate Bernoulli joint-distribution
}
\description{
This function applies the IPFP procedure to obtain a joint distribution of 
\eqn{K} multivariate binary (Bernoulli) variables \eqn{X_1}, ..., \eqn{X_K}.

It requires as input the odds ratio or alternatively the correlation as a 
measure of association between all the binary variables and a vector of marginal 
probabilities. 

This function is useful when one wants to simulate and draw from a 
multivariate binary distribution when only first order (marginal probabilities)
and second order moments (correlation or odds ratio) are available.
}
\usage{
ObtainMultBinaryDist(odds = NULL, corr = NULL, marg.probs, ...)
}
\arguments{
  \item{odds}{  
   A \eqn{K \times K}{K x K} matrix where the \eqn{i}-th row and the \eqn{j}-th 
   column represents the Odds ratio between variables \eqn{i} and \eqn{j}. Must 
   be provided if \code{corr} is not.
}
  \item{corr}{
    A \eqn{K \times K}{K x K} matrix where the \eqn{i}-th row and the \eqn{j}-th
    column represents the correlation between variables \eqn{i} and \eqn{j}. 
    Must be provided if \code{odds} is not.
}
  \item{marg.probs}{
    A vector with \eqn{K} elements of marginal probabilities where the 
    \eqn{i}-th entry refers to \eqn{P(X_i = 1)}{P(X_i = 1)}.
}
  \item{...}{
    Additional arguments that can be passed to the \code{Ipfp} function such as 
    \code{tol}, \code{iter}, \code{print} and \code{compute.cov}.
}

}

\value{
A list whose elements are mainly determined by the \code{Ipfp} function.
  \item{joint.proba}{
    The resulting multivariate joint-probabilities (from \code{Ipfp}).
}
  \item{stp.crit}{
    The final value of the \code{Ipfp} stopping criterion.
}
  \item{conv}{
    Boolean indicating whether the \code{Ipfp} algorithm converged to a 
    solution.
}
  \item{check.margins}{
    A list returning, for each margin, the absolute maximum deviation between 
    the desired and generated margin. Ideally the elements should approximate
    0 (from \code{Ipfp}).
}
  \item{label}{
    The names of the variables.
}
}
\references{
  Lee, A.J. (1993).
  Generating Random Binary Deviates Having Fixed Marginal Distributions and 
  Specified Degrees of Association
  \emph{The American Statistician}  47 (3): 209-215.
 
  Qaqish, B. F., Zink, R. C., and Preisser, J. S. (2012). 
  Orthogonalized residuals for estimation of marginally specified association 
  parameters in multivariate binary data.
  \emph{Scandinavian Journal of Statistics} 39, 515-527.
}
\author{
Thomas Suesse 

Maintainer: Johan Barthelemy <johan@uow.edu.au>.
}
\note{
It is important to note that either the odds ratio defined in \code{odds} or
the correlations described in \code{corr} must be provided.
}
\seealso{
\code{\link[mipfp:Ipfp]{Ipfp}} for the function used to estimate the 
distribution; \code{\link[mipfp:RMultBinary]{RMultBinary}} to simulate the
estimated joint-distribution; \code{\link[mipfp:Corr2Odds]{Corr2Odds}} and
\code{\link[mipfp:Odds2Corr]{Odds2Corr}} to convert odds ratio to correlation
and conversely.
}
\examples{
# initial odds ratios from Qaqish et al. (2012)
or <- matrix(c(Inf, 0.281, 2.214, 2.214, 
               0.281, Inf, 2.214, 2.214,
               2.214, 2.214, Inf, 2.185,
               2.214, 2.214, 2.185, Inf), nrow = 4, ncol = 4, byrow = TRUE)
rownames(or) <- colnames(or) <- c("Parent1", "Parent2", "Sibling1", "Sibling2")

# hypothetical marginal probabilities
p <- c(0.2, 0.4, 0.6, 0.8)

# estimating the joint-distribution
p.joint <- ObtainMultBinaryDist(odds = or, corr = NULL, marg.probs = p)
print(p.joint$joint.proba)

# obtain identical solution when providing correlation
corr <- Odds2Corr(odds = or, marg.probs = p)$corr
p.joint.alt <- ObtainMultBinaryDist(corr = corr, marg.probs = p)

# checking if the results are truly identicals
diff <- sum(abs(p.joint.alt$joint.proba - p.joint$joint.proba))
cat('Sum of the absolute deviations: ', diff, '\n')
}
\concept{Bernoulli}
\keyword{distribution}
\keyword{multivariate}

\name{spnamur}
\alias{spnamur}
\docType{data}
\title{
Synthetic population of Namur (Belgium)
}
\description{
This data drame contains a synthetic population of individuals for Belgian city
of Namur. The attributes details the gender, age class, socio-professional
status, education level and driving license ownership of every synthetic
individual.
}
\usage{data(spnamur)}

\format{
A data frame detailing the synthetic individuals whose columns are described
in the Table below.

\tabular{ll}{
  \bold{Attribute} \tab \bold{Values (levels)} \cr
  Household.type \tab C (couple); F (family with children); I (isolated); N (non
                      family) \cr
  Gender \tab F (female); H (male) \cr
  Prof.status  \tab A (active); E (student); I (inactive) \cr
  Education.level  \tab O (none); P (primary); S (high school); 
                        U (higher education) \cr
  Driving.license \tab O (no); P (yes) \cr
  Age.class	\tab 0 (0-5); 1 (6-17); 2 (18-39); 3 (40-59); 4 (60+) \cr  
}
}
\source{
  VirtualBelgium - \url{https://virtualbelgium.sourceforge.net}
}
\references{
  Barthelemy, J. and Toint, P.L. (2013)
  Synthetic population generation without a sample
  \emph{Transportation Science} 47 (2): 266-279
}
\examples{
data(spnamur)
# generating the contingency table of the synthetic population
table(spnamur)
}
\keyword{datasets}

\name{Corr2Odds}
\alias{Corr2Odds}
\title{Converting correlation to odds ratio
}
\description{
For \eqn{K} binary (Bernoulli) random variables 
\eqn{X_1}{X_1}, ..., \eqn{X_K}{X_K}, this function transforms the correlation
measure of association \eqn{C_{ij}}{C_ij} between every pair
\eqn{(X_i, X_j)}{(X_i, X_j)} to the odds ratio \eqn{O_{ij}}{O_ij} where
\deqn{C_{ij} = \frac{cov(X_i, X_j)}{\sqrt{var(X_i) * var(X_j)}}}{
C_ij = cov(X_i, X_j) / sqrt(var(X_i) * var(X_j))}
and 
\deqn{
O_{ij} = \frac{P(X_i = 1, X_j = 1) * P(X_i = 0, X_j = 0)}
            {P(X_i = 1, X_j = 0) * P(X_i = 0, X_j = 1)}.
}{
O_ij = P(X_i = 1, X_j = 1) * P(X_i = 0, X_j = 0) / 
       P(X_i = 1, X_j = 0) * P(X_i = 0, X_j = 1).}
}
\usage{
Corr2Odds(corr, marg.probs)
}
\arguments{
  \item{corr}{      
    A \eqn{K \times K}{K x K} matrix where the \eqn{i}-th row and the \eqn{j}-th
    column represents the correlation \eqn{C_{ij}}{C_ij} between variables
    \eqn{i} and \eqn{j}.  
}
  \item{marg.probs}{
    A vector with \eqn{K} elements of marginal probabilities where the 
    \eqn{i}-th entry refers to \eqn{P(X_i = 1)}{P(X_i = 1)}.
}
}
\value{
The function return a list with the correlations and the pairwise probabilities.
  \item{odds}{
    A matrix of the same dimension as \code{corr} containing the correlations
}
  \item{pair.proba}{
    A matrix of the same dimension as \code{corr} containing the pairwise 
    probabilities.
}
}
\references{
  Lee, A.J. (1993).
  Generating Random Binary Deviates Having Fixed Marginal Distributions and 
  Specified Degrees of Association
  \emph{The American Statistician} 47 (3): 209-215.
 
  Qaqish, B. F., Zink, R. C., and Preisser, J. S. (2012).
  Orthogonalized residuals for estimation of marginally specified association
  parameters in multivariate binary data.
  \emph{Scandinavian Journal of Statistics} 39, 515-527.
}
\author{
Thomas Suesse.

Maintainer: Johan Barthelemy \email{johan@uow.edu.au}.
}
\seealso{
\code{\link[mipfp:Corr2Odds]{Corr2Odds}} for converting correlation to odds 
ratio.
}
\examples{
# correlation matrix from Qaqish et al. (2012)
cr <- matrix(c( 1.000, -0.215, 0.144, 0.107,
               -0.215,  1.000, 0.184, 0.144,
                0.144,  0.184, 1.000, 0.156,
                0.107,  0.144, 0.156, 1.000), nrow = 4, ncol = 4, byrow = TRUE)
rownames(cr) <- colnames(cr) <- c("Parent1", "Parent2", "Sibling1", "Sibling2")

# hypothetical marginal probabilities
p <- c(0.2, 0.4, 0.6, 0.8)

# converting correlation to odds ratio and getting pairwise probabilities
or <- Corr2Odds(corr = cr, marg.probs = p)
print(or)
}
\concept{correlation}
\concept{odds ratio}
\concept{Bernoulli}
\concept{odds ratio}
\keyword{multivariate}
\keyword{array}
